(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs/add/operator/map'), require('rxjs/add/operator/catch'), require('rxjs/add/operator/toPromise'), require('@angular/common/http'), require('@angular/core'), require('tslib'), require('@angular/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ng2-select2-bootstrap', ['exports', 'rxjs/add/operator/map', 'rxjs/add/operator/catch', 'rxjs/add/operator/toPromise', '@angular/common/http', '@angular/core', 'tslib', '@angular/forms', '@angular/common'], factory) :
    (factory((global['ng2-select2-bootstrap'] = {}),global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.ng.common.http,global.ng.core,global.tslib,global.ng.forms,global.ng.common));
}(this, (function (exports,map,_catch,toPromise,http,core,tslib,forms,common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var SelectService = (function () {
        /**
         * @param {?} http
         */
        function SelectService(http$$1) {
            this.http = http$$1;
            this.headers = new http.HttpHeaders({ 'Content-Type': 'application/json' });
        }
        /**
         * @param {?} url
         * @param {?} parametros
         * @return {?}
         */
        SelectService.prototype.getResultados = function (url, parametros) {
            var /** @type {?} */ urlParams = this.paramns(parametros, new http.HttpParams());
            return this.http.get(url, { headers: this.headers, params: urlParams });
        };
        /**
         * @param {?} a
         * @param {?} urlParams
         * @return {?}
         */
        SelectService.prototype.paramns = function (a, urlParams) {
            for (var /** @type {?} */ prefix in a) {
                urlParams = this.buildParams(prefix, a[prefix], urlParams);
            }
            return urlParams;
        };
        /**
         * @param {?} prefix
         * @param {?} obj
         * @param {?} urlParams
         * @return {?}
         */
        SelectService.prototype.buildParams = function (prefix, obj, urlParams) {
            if (obj instanceof Array) {
                for (var /** @type {?} */ i in obj) {
                    urlParams = this.buildParams(prefix + "[" + (typeof obj[i] === "object" || Array.isArray(obj[i]) ? i : "") + "]", obj[i], urlParams);
                }
                return urlParams;
            }
            else if (obj instanceof Object) {
                for (var /** @type {?} */ name_1 in obj) {
                    if (obj[name_1] instanceof Date) {
                        obj[name_1] = JSON.stringify(obj[name_1]);
                    }
                    urlParams = this.buildParams(prefix + "[" + name_1 + "]", obj[name_1], urlParams);
                }
                return urlParams;
            }
            else {
                if (obj !== null && obj !== undefined) {
                    urlParams = urlParams.append(prefix, obj);
                }
                return urlParams;
            }
        };
        return SelectService;
    }());
    SelectService.decorators = [
        { type: core.Injectable, args: [{
                    providedIn: "root"
                },] },
    ];
    /** @nocollapse */
    SelectService.ctorParameters = function () {
        return [
            { type: http.HttpClient, },
        ];
    };
    /** @nocollapse */ SelectService.ngInjectableDef = core.defineInjectable({ factory: function SelectService_Factory() { return new SelectService(core.inject(http.HttpClient)); }, token: SelectService, providedIn: "root" });
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var HiddenDirective = (function () {
        /**
         * @param {?} elementRef
         */
        function HiddenDirective(elementRef) {
            this.elementRef = elementRef;
        }
        Object.defineProperty(HiddenDirective.prototype, "hidden", {
            /**
             * @param {?} valor
             * @return {?}
             */
            set: function (valor) {
                if (valor) {
                    this.elementRef.nativeElement.style.display = 'none';
                }
                else {
                    this.elementRef.nativeElement.style.display = 'block';
                }
            },
            enumerable: true,
            configurable: true
        });
        return HiddenDirective;
    }());
    HiddenDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[hidden]',
                },] },
    ];
    /** @nocollapse */
    HiddenDirective.ctorParameters = function () {
        return [
            { type: core.ElementRef, },
        ];
    };
    HiddenDirective.propDecorators = {
        "hidden": [{ type: core.Input, args: ['hidden',] },],
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var HighlightDirective = (function () {
        /**
         * @param {?} elementRef
         */
        function HighlightDirective(elementRef) {
            this.elementRef = elementRef;
        }
        /**
         * @return {?}
         */
        HighlightDirective.prototype.onMouseEnter = function () {
            this.highlight();
        };
        /**
         * @return {?}
         */
        HighlightDirective.prototype.onMouseLeave = function () {
            this.highlight();
        };
        /**
         * @return {?}
         */
        HighlightDirective.prototype.highlight = function () {
            if (this.elementRef.nativeElement.className.indexOf(this.classe) === -1) {
                this.elementRef.nativeElement.className += ' ' + this.classe;
            }
            else {
                this.elementRef.nativeElement.classList.remove(this.classe);
            }
        };
        return HighlightDirective;
    }());
    HighlightDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[highlight]',
                },] },
    ];
    /** @nocollapse */
    HighlightDirective.ctorParameters = function () {
        return [
            { type: core.ElementRef, },
        ];
    };
    HighlightDirective.propDecorators = {
        "classe": [{ type: core.Input, args: ['highlight',] },],
        "onMouseEnter": [{ type: core.HostListener, args: ['mouseenter',] },],
        "onMouseLeave": [{ type: core.HostListener, args: ['mouseleave',] },],
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var InfiniteScrollDirective = (function () {
        /**
         * @param {?} element
         */
        function InfiniteScrollDirective(element) {
            this.element = element;
            this._count = 0;
            this.OnScrollMethod = new core.EventEmitter();
            this._element = this.element.nativeElement;
            if (!this.scrollTrigger) {
                this.scrollTrigger = 1;
            }
        }
        /**
         * @return {?}
         */
        InfiniteScrollDirective.prototype.onScroll = function () {
            this._count++;
            if (this._element.scrollTop + this._element.clientHeight >= this._element.scrollHeight) {
                this.OnScrollMethod.emit(null);
            }
            else {
                if (this._element.scrollTop + this._element.clientHeight >= (this._element.scrollHeight - (this._element.scrollHeight * this.scrollTrigger))) {
                    this.OnScrollMethod.emit(null);
                }
            }
        };
        return InfiniteScrollDirective;
    }());
    InfiniteScrollDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[infinite-scroll]',
                    host: {
                        '(scroll)': 'onScroll($event)'
                    }
                },] },
    ];
    /** @nocollapse */
    InfiniteScrollDirective.ctorParameters = function () {
        return [
            { type: core.ElementRef, },
        ];
    };
    InfiniteScrollDirective.propDecorators = {
        "scrollTrigger": [{ type: core.Input, args: ['scroll-distance',] },],
        "OnScrollMethod": [{ type: core.Output },],
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var InnerTemplateDirective = (function () {
        /**
         * @param {?} viewContainer
         */
        function InnerTemplateDirective(viewContainer) {
            this.viewContainer = viewContainer;
        }
        Object.defineProperty(InnerTemplateDirective.prototype, "item", {
            /**
             * @param {?} item
             * @return {?}
             */
            set: function (item) {
                this._item = item;
                if (this.template) {
                    this.template.destroy();
                    this.criaTemplate();
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        InnerTemplateDirective.prototype.ngOnInit = function () {
            this.criaTemplate();
        };
        /**
         * @return {?}
         */
        InnerTemplateDirective.prototype.criaTemplate = function () {
            if (this.templateRef) {
                this.template = this.viewContainer.createEmbeddedView(this.templateRef, {
                    '\$implicit': this._item,
                    'index': this.index
                });
            }
        };
        return InnerTemplateDirective;
    }());
    InnerTemplateDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[inner-template]'
                },] },
    ];
    /** @nocollapse */
    InnerTemplateDirective.ctorParameters = function () {
        return [
            { type: core.ViewContainerRef, },
        ];
    };
    InnerTemplateDirective.propDecorators = {
        "item": [{ type: core.Input },],
        "index": [{ type: core.Input },],
        "templateRef": [{ type: core.Input, args: ['inner-template',] },],
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var Select = (function () {
        /**
         * @param {?} elementRef
         * @param {?} zone
         */
        function Select(elementRef, zone) {
            this.elementRef = elementRef;
            this.zone = zone;
            this.indiceId = 'id';
            this.indiceNome = 'nome';
            this.minimoCaracteres = 0;
            this.exibirMensagemCaracteresMinimo = true;
            this.aberto = false;
            this.focus = false;
            this.disabled = false;
            this.valoresExibir = [];
            this.change = new core.EventEmitter();
            this.onSelecionarItem = new core.EventEmitter();
            this.onBuscar = new core.EventEmitter();
            this.onApagar = new core.EventEmitter();
            this.onRemoverItem = new core.EventEmitter();
            this.onAbrir = new core.EventEmitter();
            this.onFechar = new core.EventEmitter();
            this.onLimpar = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        Select.prototype.ngOnInit = function () {
            if (this.minimoCaracteres == 0) {
                this.exibirMensagemCaracteresMinimo = false;
            }
            this.elementRef.nativeElement.setAttribute("style", "float:left;width:100%");
        };
        /**
         * @param {?} valor
         * @return {?}
         */
        Select.prototype.setFocus = function (valor) {
            if (this.disabled) {
                return false;
            }
            this.focus = valor;
        };
        /**
         * @return {?}
         */
        Select.prototype.fechar = function () {
            this.aberto = false;
            this.valoresExibir = [];
            this.setFocus(true);
            this.setFocus(false);
            this.onFechar.emit(true);
        };
        /**
         * @param {?} item
         * @return {?}
         */
        Select.prototype.selecionar = function (item) {
            this.updateValue(this.data);
            this.onSelecionarItem.emit(item);
            //apaga campo de busca
            this.campoBusca.nativeElement.value = '';
            this.fechar();
        };
        /**
         * @param {?} valor
         * @return {?}
         */
        Select.prototype.keyup = function (valor) {
            if (this.valorPesquisado == valor) {
                return null;
            }
            this.valoresExibir = [];
            this.valorPesquisado = valor;
            this.buscar();
        };
        /**
         * @return {?}
         */
        Select.prototype.buscar = function () {
        };
        /**
         * @return {?}
         */
        Select.prototype.abrir = function () {
        };
        /**
         * quando está marcado para exibir resultado completo
         * @param {?} item
         * @param {?} event
         * @return {?}
         */
        Select.prototype.remove = function (item, event) {
            var _this = this;
            event.stopPropagation();
            this.fechar();
            // let itens
            var /** @type {?} */ posicao = this.data.findIndex(function (procurar) { return procurar[_this.indiceId] == item[_this.indiceId]; });
            if (posicao !== -1) {
                this.data.splice(posicao, 1);
            }
            this.onRemoverItem.emit(item);
            if (this.data.length == 0) {
                this.aberto = false;
                this.abrir();
            }
        };
        /**
         * @return {?}
         */
        Select.prototype.getClassGeral = function () {
            return {
                'select2-container--focus': this.focus,
                'select2 select2-container select2-container--bootstrap select2-container--above': true,
                'select2-container--disabled': this.disabled
            };
        };
        /**
         * @param {?} event
         * @return {?}
         */
        Select.prototype.clickForaComponent = function (event) {
            if (!this.elementRef.nativeElement.contains(event.target) && this.aberto) {
                this.fechar();
            }
        };
        /**
         * @return {?}
         */
        Select.prototype.validaCaracteresMinimo = function () {
            if (this.minimoCaracteres > 0) {
                if (this.valorPesquisado.length < this.minimoCaracteres) {
                    return false;
                }
                this.exibirMensagemCaracteresMinimo = false;
            }
            return true;
        };
        /**
         * @param {?} value
         * @return {?}
         */
        Select.prototype.writeValue = function (value) {
            this.data = value;
            this._value = value;
            this.updateValue(this._value);
        };
        /**
         * @param {?} value
         * @return {?}
         */
        Select.prototype.updateValue = function (value) {
            var _this = this;
            this.zone.run(function () {
                if (_this._value != value) {
                    _this._value = value;
                    _this.onChange(value);
                    _this._onTouchedCallback();
                    // this.change.emit(value);
                }
            });
        };
        /**
         * @param {?} _
         * @return {?}
         */
        Select.prototype.onChange = function (_) { };
        /**
         * @return {?}
         */
        Select.prototype.onTouched = function () { };
        /**
         * @param {?} fn
         * @return {?}
         */
        Select.prototype.registerOnChange = function (fn) { this.onChange = fn; };
        /**
         * @param {?} fn
         * @return {?}
         */
        Select.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
        /**
         * @param {?} _
         * @return {?}
         */
        Select.prototype._onChangeCallback = function (_) { };
        /**
         * @return {?}
         */
        Select.prototype._onTouchedCallback = function () { };
        return Select;
    }());
    var MultipleComponent = (function (_super) {
        tslib.__extends(MultipleComponent, _super);
        /**
         * @param {?} elementRef
         * @param {?} zone
         */
        function MultipleComponent(elementRef, zone) {
            var _this = _super.call(this, elementRef, zone) || this;
            _this.elementRef = elementRef;
            _this.zone = zone;
            _this.name = '';
            _this.classe = '';
            _this.placeholder = 'Selecione';
            _this.minimoCaracteres = 0;
            _this.disabled = false;
            _this.indiceId = 'id';
            _this.indiceNome = 'nome';
            _this.change = new core.EventEmitter();
            _this.onSelecionarItem = new core.EventEmitter();
            _this.onBuscar = new core.EventEmitter();
            _this.onApagar = new core.EventEmitter();
            _this.onRemoverItem = new core.EventEmitter();
            _this.onAbrir = new core.EventEmitter();
            _this.onFechar = new core.EventEmitter();
            _this.onLimpar = new core.EventEmitter();
            return _this;
        }
        Object.defineProperty(MultipleComponent.prototype, "valores", {
            /**
             * @param {?} valor
             * @return {?}
             */
            set: function (valor) {
                this._valores = valor;
                this.valoresExibir = valor;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MultipleComponent.prototype.abrir = function () {
            if (this.disabled) {
                return false;
            }
            if (this.aberto) {
                this.fechar();
            }
            else {
                this.aberto = true;
                if (!this.data) {
                    this.data = [];
                }
                if (!this._value) {
                    this._value = [];
                }
                this.valorPesquisado = '';
                this.campoBusca.nativeElement.focus();
                this.setFocus(true);
                this.onAbrir.emit(true);
                this.buscar();
            }
        };
        /**
         * @param {?} item
         * @return {?}
         */
        MultipleComponent.prototype.selecionar = function (item) {
            var _this = this;
            //verifica se ja foi adicionado
            var /** @type {?} */ jaExiste = this.data.findIndex(function (procurar) { return procurar[_this.indiceId] == item[_this.indiceId]; });
            if (jaExiste === -1) {
                this.data.push(item);
            }
            this.updateValue(this.data);
            this.onSelecionarItem.emit(item);
            this.fechar();
            //apaga campo de busca
            this.campoBusca.nativeElement.value = '';
        };
        /**
         * @return {?}
         */
        MultipleComponent.prototype.getSomenteId = function () {
            var /** @type {?} */ ids = [];
            try {
                for (var _a = tslib.__values(this.data), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var item = _b.value;
                    ids.push(item[this.indiceId]);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return))
                        _c.call(_a);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return ids;
            var e_1, _c;
        };
        /**
         * @param {?} event
         * @return {?}
         */
        MultipleComponent.prototype.limpar = function (event) {
            event.stopPropagation();
            this.data = null;
            this.updateValue(null);
            this.onLimpar.emit(true);
            this.aberto = false;
            this.abrir();
        };
        /**
         * @param {?} item
         * @param {?} event
         * @return {?}
         */
        MultipleComponent.prototype.remove = function (item, event) {
            _super.prototype.remove.call(this, item, event);
            this.updateValue(this.data);
        };
        /**
         * @return {?}
         */
        MultipleComponent.prototype.buscar = function () {
            var _this = this;
            if (this.validaCaracteresMinimo() == false) {
                return false;
            }
            this.onBuscar.emit(this.valorPesquisado);
            this.valoresExibir = this._valores.filter(function (item) {
                var /** @type {?} */ pesquisa = item[_this.indiceNome].toString().toLocaleLowerCase().indexOf(_this.valorPesquisado.toString().toLocaleLowerCase());
                //verifica se o item da lista original ja n esta add na lista data
                var /** @type {?} */ jaFoiAdicionado = _this.data.findIndex(function (procurar) { return procurar[_this.indiceId] == item[_this.indiceId]; });
                if (pesquisa !== -1 && jaFoiAdicionado === -1) {
                    return item;
                }
            });
        };
        Object.defineProperty(MultipleComponent.prototype, "value", {
            /**
             * @return {?}
             */
            get: function () { return this._value; },
            /**
             * @param {?} v
             * @return {?}
             */
            set: function (v) {
                if (v !== this._value) {
                    this._value = (v);
                    this._onChangeCallback(v);
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} value
         * @return {?}
         */
        MultipleComponent.prototype.writeValue = function (value) {
            this.data = value;
            this._value = value;
        };
        /**
         * @param {?} value
         * @return {?}
         */
        MultipleComponent.prototype.updateValue = function (value) {
            var _this = this;
            this.zone.run(function () {
                _this._value = value;
                _this.onChange(value);
                _this._onTouchedCallback();
                _this.change.emit(value);
            });
        };
        /**
         * @param {?} _
         * @return {?}
         */
        MultipleComponent.prototype.onChange = function (_) { };
        /**
         * @return {?}
         */
        MultipleComponent.prototype.onTouched = function () { };
        /**
         * @param {?} fn
         * @return {?}
         */
        MultipleComponent.prototype.registerOnChange = function (fn) { this.onChange = fn; };
        /**
         * @param {?} fn
         * @return {?}
         */
        MultipleComponent.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
        /**
         * @param {?} _
         * @return {?}
         */
        MultipleComponent.prototype._onChangeCallback = function (_) { };
        /**
         * @return {?}
         */
        MultipleComponent.prototype._onTouchedCallback = function () { };
        return MultipleComponent;
    }(Select));
    MultipleComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'select2-multiple',
                    template: "\n        <!--select simples-->\n        <span [ngClass]=\"getClassGeral()\" dir=\"ltr\" (click)=\"abrir()\">\n        <span class=\"selection\">\n            <span class=\"select2-selection select2-selection--multiple\" role=\"combobox\" aria-haspopup=\"true\" aria-expanded=\"false\" tabindex=\"-1\">\n            <ul class=\"select2-selection__rendered\">\n                <li [hidden]=\"data\" [innerHtml]=\"placeholder\"  class=\"select2-selection__placeholder\"></li>\n                <span [hidden]=\"!data\" >\n                    <span [inner-template]=\"templateSelecionado || templateSelecionadoInterno\" [item]=\"this\"></span>\n                </span>\n                <li class=\"select2-selection__arrow\" role=\"presentation\"><b role=\"presentation\"></b></li>\n            </ul>\n        </span>\n        </span>\n        <span class=\"dropdown-wrapper\" aria-hidden=\"true\"></span>\n    </span>\n\n        <!--quando clicar campo-->\n        <div [hidden]=\"!aberto\">\n        <span class=\"select2-container select2-container--bootstrap select2-container--open\">\n            <span class=\"select2-dropdown select2-dropdown--below\" dir=\"ltr\" >\n                <span class=\"select2-search select2-search--dropdown\">\n                    <input (keyup)=\"keyup($event.target.value)\" #campoBusca placeholder=\"Digite algo\" autofocus class=\"select2-search__field\" type=\"search\" tabindex=\"0\" autocomplete=\"off\" autocorrect=\"off\" autocapitalize=\"off\" spellcheck=\"false\" role=\"textbox\">\n                </span>\n                <span class=\"select2-results\">\n                    <ul class=\"select2-results__options\" role=\"tree\"  aria-expanded=\"true\" aria-hidden=\"false\">\n                        <span [hidden]=\"exibirMensagemCaracteresMinimo\">\n                            <span [hidden]=\"valoresExibir.length == 0\" >\n                                <li *ngFor=\"let item of valoresExibir\" (click)=\"selecionar(item)\" class=\"select2-results__option\" highlight=\"select2-results__option--highlighted\" role=\"treeitem\" [attr.aria-selected]=\"((_value) && (item[indiceId] == _value[indiceId])) ? true : false\">\n                                    <span  [inner-template]=\"templateResultado || templateResultadoInterno\" [item]=\"item\"></span>\n                                </li>\n                            </span>\n                            <li [hidden]=\"valoresExibir.length > 0\" class=\"select2-results__option select2-results__message\" aria-live=\"assertive\">\n                                <span  [inner-template]=\"templateSemResultado || templateSemResultadoInterno\" [item]=\"{pesquisa:valorPesquisado}\"></span>\n                            </li>\n                        </span>\n                        <li [hidden]=\"exibirMensagemCaracteresMinimo == false\" class=\"select2-results__option select2-results__message\">\n                            Digite {{minimoCaracteres}} ou mais caracteres para realizar a busca\n                        </li>\n                    </ul>\n                </span>\n            </span>\n        </span>\n        </div>\n\n\n\n        <ng-template #templateSemResultadoInterno>\n            Nenhum resultado encontrado\n        </ng-template>\n        <ng-template #templateResultadoInterno let-valor>\n            {{valor[indiceNome]}}\n        </ng-template>\n        <ng-template #templateSelecionadoInterno let-valor>\n        <span *ngIf=\"valor\">\n            <li *ngFor=\"let item of valor.data\" class=\"select2-selection__choice\">\n                <span class=\"select2-selection__choice__remove\" role=\"presentation\" (click)=\"valor.remove(item, $event)\">\u00D7</span>\n                {{item[indiceNome]}}\n            </li>\n        </span>\n        </ng-template>\n    ",
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return MultipleComponent; }),
                            multi: true
                        }
                    ],
                    host: {
                        '(document:click)': 'clickForaComponent($event)',
                        '(focus)': 'setFocus(true)',
                        '(blur)': 'setFocus(false)',
                    },
                },] },
    ];
    /** @nocollapse */
    MultipleComponent.ctorParameters = function () {
        return [
            { type: core.ElementRef, },
            { type: core.NgZone, },
        ];
    };
    MultipleComponent.propDecorators = {
        "name": [{ type: core.Input },],
        "classe": [{ type: core.Input },],
        "placeholder": [{ type: core.Input },],
        "minimoCaracteres": [{ type: core.Input },],
        "templateResultado": [{ type: core.Input },],
        "templateSelecionado": [{ type: core.Input },],
        "templateSemResultado": [{ type: core.Input },],
        "disabled": [{ type: core.Input },],
        "indiceId": [{ type: core.Input },],
        "indiceNome": [{ type: core.Input },],
        "valores": [{ type: core.Input },],
        "change": [{ type: core.Output },],
        "onSelecionarItem": [{ type: core.Output },],
        "onBuscar": [{ type: core.Output },],
        "onApagar": [{ type: core.Output },],
        "onRemoverItem": [{ type: core.Output },],
        "onAbrir": [{ type: core.Output },],
        "onFechar": [{ type: core.Output },],
        "onLimpar": [{ type: core.Output },],
        "campoBusca": [{ type: core.ViewChild, args: ['campoBusca',] },],
        "value": [{ type: core.Input },],
    };
    var RequestComponent = (function (_super) {
        tslib.__extends(RequestComponent, _super);
        /**
         * @param {?} elementRef
         * @param {?} zone
         * @param {?} requisicao
         * @param {?} renderer
         */
        function RequestComponent(elementRef, zone, requisicao, renderer) {
            var _this = _super.call(this, elementRef, zone) || this;
            _this.elementRef = elementRef;
            _this.zone = zone;
            _this.requisicao = requisicao;
            _this.renderer = renderer;
            _this.name = '';
            _this.classe = '';
            _this.minimoCaracteres = 0;
            _this.placeholder = 'Selecione';
            _this.disabled = false;
            _this.indiceId = 'id';
            _this.indiceNome = 'nome';
            _this.change = new core.EventEmitter();
            _this.onSelecionarItem = new core.EventEmitter();
            _this.onBuscar = new core.EventEmitter();
            _this.onApagar = new core.EventEmitter();
            _this.onRemoverItem = new core.EventEmitter();
            _this.onAbrir = new core.EventEmitter();
            _this.onFechar = new core.EventEmitter();
            _this.onLimpar = new core.EventEmitter();
            _this.onErro = new core.EventEmitter();
            _this.onProcessaResultado = new core.EventEmitter();
            _this.onProcessaParametros = new core.EventEmitter();
            _this.pagina = 1;
            _this.quantidadePadrao = 0;
            _this.buscando = false;
            _this.semResultado = false;
            return _this;
        }
        /**
         * @return {?}
         */
        RequestComponent.prototype.ngOnDestroy = function () {
            if (this.subscrebeBusca) {
                this.subscrebeBusca.unsubscribe();
            }
        };
        /**
         * @return {?}
         */
        RequestComponent.prototype.abrir = function () {
            if (this.disabled) {
                return false;
            }
            if (this.aberto) {
                this.fechar();
            }
            else {
                this.setFocus(true);
                this.aberto = true;
                // this.renderer.invokeElementMethod(this.campoBusca.nativeElement, 'focus', []);
                this.pagina = 1;
                this.semResultado = false;
                this.quantidadePadrao = 0;
                this.valorPesquisado = '';
                this.campoBusca.nativeElement.value = '';
                this.setFocus(true);
                this.onAbrir.emit(true);
                this.buscar();
            }
        };
        /**
         * @param {?} valor
         * @return {?}
         */
        RequestComponent.prototype.keyup = function (valor) {
            if (this.valorPesquisado == valor) {
                return null;
            }
            this.valoresExibir = [];
            this.valorPesquisado = valor;
            this.pagina = 1;
            this.buscar();
        };
        /**
         * @param {?} item
         * @return {?}
         */
        RequestComponent.prototype.selecionar = function (item) {
            this.data = item;
            _super.prototype.selecionar.call(this, item);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        RequestComponent.prototype.limpar = function (event) {
            event.stopPropagation();
            this.data = null;
            this.updateValue(null);
            this.onLimpar.emit(true);
            if (this.aberto) {
                this.fechar();
            }
            else {
                this.abrir();
            }
        };
        /**
         * @return {?}
         */
        RequestComponent.prototype.buscar = function () {
            var _this = this;
            if (this.validaCaracteresMinimo() == false) {
                return false;
            }
            this.buscando = true;
            // this.valoresExibir = this._valores.filter(item => item[this.indiceNome].indexOf(this.valorPesquisado) !== -1);
            var /** @type {?} */ parametros = {
                enviado: {
                    pagina: this.pagina,
                    valorPesquisado: this.valorPesquisado,
                },
                retorno: {}
            };
            //mata o subscribe
            this.ngOnDestroy();
            this.onBuscar.emit(this.valorPesquisado);
            this.onProcessaParametros.emit(parametros);
            this.subscrebeBusca = this.requisicao.getResultados(this.url, parametros.retorno).subscribe(function (resultado) {
                var /** @type {?} */ objEmit = { enviado: resultado, retorno: [] };
                _this.onProcessaResultado.emit(objEmit);
                var /** @type {?} */ exibirResultado = objEmit.retorno;
                if (Array.isArray(exibirResultado)) {
                    if (_this.quantidadePadrao == 0) {
                        _this.quantidadePadrao = exibirResultado.length;
                    }
                    if (_this.quantidadePadrao != exibirResultado.length) {
                        _this.semResultado = true;
                    }
                    _this.valoresExibir = _this.valoresExibir.concat(exibirResultado);
                }
                else {
                    console.log('Ng2Select2Bootstrap: retorno não é um select', exibirResultado);
                }
                _this.buscando = false;
            }, function (erro) {
                console.log(erro);
                if (erro.status == 409) {
                    _this.semResultado = true;
                }
                _this.onErro.emit(erro);
                _this.buscando = false;
            });
        };
        /**
         * @return {?}
         */
        RequestComponent.prototype.onScroll = function () {
            if (!this.buscando && !this.semResultado) {
                this.pagina++;
                this.buscar();
            }
        };
        Object.defineProperty(RequestComponent.prototype, "value", {
            /**
             * @return {?}
             */
            get: function () { return this._value; },
            /**
             * @param {?} v
             * @return {?}
             */
            set: function (v) {
                if (v !== this._value) {
                    this._value = v;
                    this._onChangeCallback(v);
                }
            },
            enumerable: true,
            configurable: true
        });
        return RequestComponent;
    }(Select));
    RequestComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'select2-request',
                    template: "\n\n<!--select simples-->\n<span [ngClass]=\"getClassGeral()\" [tabindex]=\"tabIndex\" dir=\"ltr\" (focus)=\"abrir()\" (click)=\"abrir()\">\n        <span class=\"selection\">\n            <!--simples-->\n            <span class=\"select2-selection select2-selection--single\" role=\"combobox\" aria-haspopup=\"true\" aria-expanded=\"false\" tabindex=\"0\" [ngStyle]=\"styleItemSelecionado\">\n                <span class=\"select2-selection__rendered\">\n                    <span [hidden]=\"!data\" (click)=\"limpar($event)\" class=\"select2-selection__clear\">\u00D7</span>\n                    <span [hidden]=\"!data\" [inner-template]=\"templateSelecionado || templateSelecionadoInterno\" [item]=\"data\"></span>\n                    <span [hidden]=\"data\" [innerHtml]=\"placeholder\" class=\"select2-selection__placeholder\"></span>\n\n                </span>\n                <span class=\"select2-selection__arrow\" role=\"presentation\">\n                    <b role=\"presentation\"></b>\n                </span>\n            </span>\n        </span>\n        <span class=\"dropdown-wrapper\" aria-hidden=\"true\"></span>\n    </span>\n\n<!--quando clicar campo-->\n<div [hidden]=\"!aberto\">\n    <div class=\"select2-container select2-container--bootstrap select2-container--open\">\n        <div class=\"select2-dropdown select2-dropdown--below\" style=\"z-index: 999999\" dir=\"ltr\" >\n            <div class=\"select2-search select2-search--dropdown\">\n                <input (keyup)=\"keyup($event.target.value)\" #campoBusca placeholder=\"Digite algo\" autofocus class=\"select2-search__field\" type=\"search\" tabindex=\"0\" autocomplete=\"off\" autocorrect=\"off\" autocapitalize=\"off\" spellcheck=\"false\" role=\"textbox\">\n            </div>\n            <span class=\"select2-results\" aria-expanded=\"true\" aria-hidden=\"false\">\n                        <ul\n                                class=\"select2-results__options\"\n                                role=\"tree\"\n                                infinite-scroll\n                                scroll-distance=\"0,30\"\n                                (OnScrollMethod)=\"onScroll()\"\n                                style=\" overflow: auto!important;\"\n                        >\n                            <div [style.display]=\"(exibirMensagemCaracteresMinimo) ? 'none': ''\">\n                                <div [style.display]=\"(valoresExibir.length == 0) ? 'none':''\" >\n                                    <!--<ng-template -->\n                                    <!--*ngIf=\"templateLista\"-->\n                                    <!--[inner-template]=\"templateLista\" -->\n                                    <!--[item]=\"{valoresExibir: valoresExibir, component: this}\"-->\n                                    <!--&gt;-->\n                                    <!--</ng-template>-->\n                                    <!--<ng-template *ngIf=\"!templateLista\">-->\n\n                                    <!--</ng-template>-->\n                                    <ng-template [inner-template]=\"templateLista || templateListaInterno\" [item]=\"{component: this}\">\n\n                                    </ng-template>\n\n                                </div>\n\n                                <li [style.display]=\"(buscando || valoresExibir.length > 0) ? 'none' : ''\" class=\"select2-results__option select2-results__message\" aria-live=\"assertive\">\n                                    <ng-template  [inner-template]=\"templateSemResultado || templateSemResultadoInterno\" [item]=\"{pesquisa:valorPesquisado}\"></ng-template>\n                                </li>\n                                <li [style.display]=\"(!buscando) ? 'none' : ''\">\n                                    <ng-template [inner-template]=\"templateBuscando || templateBuscandoInterno\"></ng-template>\n                                </li>\n                            </div>\n                            <li [style.display]=\"(exibirMensagemCaracteresMinimo == false) ? 'none': ''\" class=\"select2-results__option select2-results__message\">\n                                Digite {{minimoCaracteres}} ou mais caracteres para realizar a busca\n                            </li>\n                        </ul>\n                    </span>\n        </div>\n    </div>\n</div>\n\n\n\n<ng-template #templateSemResultadoInterno>\n    Nenhum resultado encontrado\n</ng-template>\n<ng-template #templateResultadoInterno let-valor>\n    {{valor[indiceNome]}}\n</ng-template>\n<ng-template #templateSelecionadoInterno let-valor>\n        <span *ngIf=\"valor\"  [ngStyle]=\"styleItemSelecionado\">\n            {{valor[indiceNome]}}\n        </span>\n</ng-template>\n<ng-template #templateBuscandoInterno>\n    <span class=\"fa fa-5x fa-refresh fa-spin\" style=\" width: auto;margin:auto 50% !important\"></span>\n</ng-template>\n<ng-template #templateListaInterno let-valor>\n    <li\n            *ngFor=\"let item of valor.component.valoresExibir\"\n            (click)=\"valor.component.selecionar(item)\" class=\"select2-results__option\"\n            highlight=\"select2-results__option--highlighted\"\n            role=\"treeitem\"\n            [attr.aria-selected]=\"((_value) && (item[valor.component.indiceId] == _value[valor.component.indiceId])) ? true : false\"\n\n    >\n        <div [inner-template]=\"templateResultado || templateResultadoInterno\" [item]=\"item\"></div>\n    </li>\n</ng-template>",
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return RequestComponent; }),
                            multi: true
                        }
                    ],
                    host: {
                        '(document:click)': 'clickForaComponent($event)',
                        '(focus)': 'abrir()',
                        '(blur)': 'fechar()',
                    },
                },] },
    ];
    /** @nocollapse */
    RequestComponent.ctorParameters = function () {
        return [
            { type: core.ElementRef, },
            { type: core.NgZone, },
            { type: SelectService, },
            { type: core.Renderer, },
        ];
    };
    RequestComponent.propDecorators = {
        "name": [{ type: core.Input },],
        "classe": [{ type: core.Input },],
        "tabIndex": [{ type: core.Input },],
        "styleItemSelecionado": [{ type: core.Input },],
        "minimoCaracteres": [{ type: core.Input },],
        "placeholder": [{ type: core.Input },],
        "templateResultado": [{ type: core.Input },],
        "templateLista": [{ type: core.Input },],
        "templateSelecionado": [{ type: core.Input },],
        "templateSemResultado": [{ type: core.Input },],
        "templateBuscando": [{ type: core.Input },],
        "disabled": [{ type: core.Input },],
        "indiceId": [{ type: core.Input },],
        "indiceNome": [{ type: core.Input },],
        "url": [{ type: core.Input },],
        "change": [{ type: core.Output },],
        "onSelecionarItem": [{ type: core.Output },],
        "onBuscar": [{ type: core.Output },],
        "onApagar": [{ type: core.Output },],
        "onRemoverItem": [{ type: core.Output },],
        "onAbrir": [{ type: core.Output },],
        "onFechar": [{ type: core.Output },],
        "onLimpar": [{ type: core.Output },],
        "onErro": [{ type: core.Output },],
        "onProcessaResultado": [{ type: core.Output },],
        "onProcessaParametros": [{ type: core.Output },],
        "campoBusca": [{ type: core.ViewChild, args: ['campoBusca',] },],
        "value": [{ type: core.Input },],
    };
    var RequestMultipleComponent = (function (_super) {
        tslib.__extends(RequestMultipleComponent, _super);
        /**
         * @param {?} elementRef
         * @param {?} zone
         * @param {?} requisicao
         * @param {?} renderer
         */
        function RequestMultipleComponent(elementRef, zone, requisicao, renderer) {
            var _this = _super.call(this, elementRef, zone) || this;
            _this.elementRef = elementRef;
            _this.zone = zone;
            _this.requisicao = requisicao;
            _this.renderer = renderer;
            _this.name = '';
            _this.classe = '';
            _this.placeholder = 'Selecione';
            _this.minimoCaracteres = 0;
            _this.disabled = false;
            _this.indiceId = 'id';
            _this.indiceNome = 'nome';
            _this.change = new core.EventEmitter();
            _this.onSelecionarItem = new core.EventEmitter();
            _this.onBuscar = new core.EventEmitter();
            _this.onApagar = new core.EventEmitter();
            _this.onRemoverItem = new core.EventEmitter();
            _this.onAbrir = new core.EventEmitter();
            _this.onFechar = new core.EventEmitter();
            _this.onLimpar = new core.EventEmitter();
            _this.onErro = new core.EventEmitter();
            _this.onProcessaResultado = new core.EventEmitter();
            _this.onProcessaParametros = new core.EventEmitter();
            _this.pagina = 1;
            _this.quantidadePadrao = 0;
            _this.buscando = false;
            _this.semResultado = false;
            return _this;
        }
        /**
         * @return {?}
         */
        RequestMultipleComponent.prototype.ngOnDestroy = function () {
            if (this.subscrebeBusca) {
                this.subscrebeBusca.unsubscribe();
            }
        };
        /**
         * @return {?}
         */
        RequestMultipleComponent.prototype.abrir = function () {
            if (this.disabled) {
                return false;
            }
            if (this.aberto) {
                this.fechar();
            }
            else {
                this.aberto = true;
                if (!this.data) {
                    this.data = [];
                }
                this.onAbrir.emit(true);
                // this.renderer.invokeElementMethod(this.campoBusca.nativeElement, 'focus', []);
                this.pagina = 1;
                this.semResultado = false;
                this.quantidadePadrao = 0;
                this.valorPesquisado = '';
                this.campoBusca.nativeElement.value = '';
                this.setFocus(true);
                this.buscar();
            }
        };
        /**
         * @param {?} valor
         * @return {?}
         */
        RequestMultipleComponent.prototype.keyup = function (valor) {
            if (this.valorPesquisado == valor) {
                return null;
            }
            this.valoresExibir = [];
            this.valorPesquisado = valor;
            this.pagina = 1;
            this.buscar();
        };
        /**
         * @param {?} item
         * @return {?}
         */
        RequestMultipleComponent.prototype.selecionar = function (item) {
            var _this = this;
            var /** @type {?} */ jaExiste = this.data.findIndex(function (procurar) { return procurar[_this.indiceId] == item[_this.indiceId]; });
            if (jaExiste === -1) {
                this.data.push(item);
            }
            this.updateValue(this.data);
            this.onSelecionarItem.emit(item);
            this.fechar();
            //apaga campo de busca
            this.campoBusca.nativeElement.value = '';
        };
        /**
         * @return {?}
         */
        RequestMultipleComponent.prototype.getSomenteId = function () {
            var /** @type {?} */ ids = [];
            try {
                for (var _a = tslib.__values(this.data), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var item = _b.value;
                    ids.push(item[this.indiceId]);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return))
                        _c.call(_a);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return ids;
            var e_1, _c;
        };
        /**
         * @return {?}
         */
        RequestMultipleComponent.prototype.limpar = function () {
            this.data = [];
            this.updateValue(null);
            this.aberto = false;
            this.onLimpar.emit(true);
            this.abrir();
        };
        /**
         * @return {?}
         */
        RequestMultipleComponent.prototype.buscar = function () {
            var _this = this;
            if (this.validaCaracteresMinimo() == false) {
                return false;
            }
            this.buscando = true;
            // this.valoresExibir = this._valores.filter(item => item[this.indiceNome].indexOf(this.valorPesquisado) !== -1);
            var /** @type {?} */ parametros = {
                enviado: {
                    pagina: this.pagina,
                    valorPesquisado: this.valorPesquisado,
                    idSelecionados: this.getSomenteId(),
                },
                retorno: {}
            };
            //mata o subscribe
            this.ngOnDestroy();
            this.onBuscar.emit(this.valorPesquisado);
            this.onProcessaParametros.emit(parametros);
            this.subscrebeBusca = this.requisicao.getResultados(this.url, parametros.retorno).subscribe(function (resultado) {
                var /** @type {?} */ objEmit = { enviado: resultado, retorno: [] };
                _this.onProcessaResultado.emit(objEmit);
                var /** @type {?} */ exibirResultado = objEmit.retorno;
                if (Array.isArray(exibirResultado)) {
                    if (_this.quantidadePadrao == 0 && exibirResultado.length < 25) {
                        _this.semResultado = true;
                    }
                    if (_this.quantidadePadrao == 0) {
                        _this.quantidadePadrao = exibirResultado.length;
                    }
                    if (_this.quantidadePadrao != exibirResultado.length) {
                        _this.semResultado = true;
                    }
                    _this.valoresExibir = _this.valoresExibir.concat(exibirResultado);
                }
                else {
                    console.log('Ng2Select2Bootstrap: retorno não é um select', exibirResultado);
                }
                _this.buscando = false;
            }, function (erro) {
                if (erro.status == 409) {
                    _this.semResultado = true;
                }
                _this.onErro.emit(erro);
                _this.buscando = false;
            });
        };
        /**
         * @return {?}
         */
        RequestMultipleComponent.prototype.onScroll = function () {
            if (!this.buscando && !this.semResultado) {
                this.pagina++;
                this.buscar();
            }
        };
        Object.defineProperty(RequestMultipleComponent.prototype, "value", {
            /**
             * @return {?}
             */
            get: function () { return this._value; },
            /**
             * @param {?} v
             * @return {?}
             */
            set: function (v) {
                if (v !== this._value) {
                    this._value = v;
                    this._onChangeCallback(v);
                }
            },
            enumerable: true,
            configurable: true
        });
        return RequestMultipleComponent;
    }(Select));
    RequestMultipleComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'select2-request-multiple',
                    template: "\n        <span [ngClass]=\"getClassGeral()\"  dir=\"ltr\" (click)=\"abrir()\">\n        <span class=\"selection\">\n            <span class=\"select2-selection select2-selection--multiple\" role=\"combobox\" aria-haspopup=\"true\" aria-expanded=\"false\" tabindex=\"-1\">\n            <ul class=\"select2-selection__rendered\">\n                <li [hidden]=\"data\" [innerHtml]=\"placeholder\"  class=\"select2-selection__placeholder\"></li>\n                <span [hidden]=\"!data\" >\n                    <span [inner-template]=\"templateSelecionado || templateSelecionadoInterno\" [item]=\"this\"></span>\n                </span>\n                <li class=\"select2-selection__arrow\" role=\"presentation\"><b role=\"presentation\"></b></li>\n            </ul>\n        </span>\n        </span>\n        <span class=\"dropdown-wrapper\" aria-hidden=\"true\"></span>\n    </span>\n\n        <!--quando clicar campo-->\n        <div [hidden]=\"!aberto\">\n        <span class=\"select2-container select2-container--bootstrap select2-container--open\">\n            <span class=\"select2-dropdown select2-dropdown--below\" style=\"z-index: 999999\" dir=\"ltr\" >\n                <span class=\"select2-search select2-search--dropdown\">\n                    <input (keyup)=\"keyup($event.target.value)\" #campoBusca placeholder=\"Digite algo\" autofocus class=\"select2-search__field\" type=\"search\" tabindex=\"0\" autocomplete=\"off\" autocorrect=\"off\" autocapitalize=\"off\" spellcheck=\"false\" role=\"textbox\">\n                </span>\n                <span class=\"select2-results\" aria-expanded=\"true\" aria-hidden=\"false\">\n                    <ul\n                            class=\"select2-results__options\"\n                            role=\"tree\"\n                            infinite-scroll\n                            scroll-distance=\"0,30\"\n                            (OnScrollMethod)=\"onScroll()\"\n                            style=\" overflow: auto!important;\"\n                    >\n                        <div [style.display]=\"(exibirMensagemCaracteresMinimo) ? 'none': ''\">\n                            <span [style.display]=\"(valoresExibir.length == 0) ? 'none':''\" >\n                                <ng-template [inner-template]=\"templateLista || templateListaInterno\" [item]=\"{component: this}\"></ng-template>\n                            </span>\n                            <li [style.display]=\"(buscando || valoresExibir.length > 0) ? 'none' : ''\" class=\"select2-results__option select2-results__message\" aria-live=\"assertive\">\n                                <span  [inner-template]=\"templateSemResultado || templateSemResultadoInterno\" [item]=\"{pesquisa:valorPesquisado}\"></span>\n                            </li>\n                            <li [style.display]=\"(!buscando) ? 'none' : ''\">\n                                <span [inner-template]=\"templateBuscando || templateBuscandoInterno\"></span>\n                            </li>\n                        </div>\n                        <li [style.display]=\"(exibirMensagemCaracteresMinimo == false) ? 'none': ''\" class=\"select2-results__option select2-results__message\">\n                            Digite {{minimoCaracteres}} ou mais caracteres para realizar a busca\n                        </li>\n                    </ul>\n                </span>\n            </span>\n        </span>\n        </div>\n\n\n\n        <ng-template #templateSemResultadoInterno>\n            Nenhum resultado encontrado\n        </ng-template>\n        <ng-template #templateResultadoInterno let-valor>\n            {{valor[indiceNome]}}\n        </ng-template>\n        <ng-template #templateSelecionadoInterno let-valor>\n       <span *ngIf=\"valor\">\n            <li *ngFor=\"let item of valor.data\" class=\"select2-selection__choice\">\n                <span class=\"select2-selection__choice__remove\" role=\"presentation\" (click)=\"valor.remove(item, $event)\">\u00D7</span>\n                {{item[indiceNome]}}\n            </li>\n        </span>\n        </ng-template>\n        <ng-template #templateBuscandoInterno>\n            <span class=\"fa fa-5x fa-refresh fa-spin\" style=\" width: auto;margin:auto 50% !important\"></span>\n        </ng-template>\n         <ng-template #templateListaInterno let-valor>\n            <li \n                *ngFor=\"let item of valor.component.valoresExibir\" \n                (click)=\"valor.component.selecionar(item)\" class=\"select2-results__option\" \n                highlight=\"select2-results__option--highlighted\" \n                role=\"treeitem\" \n                [attr.aria-selected]=\"((_value) && (item[valor.component.indiceId] == _value[valor.component.indiceId])) ? true : false\"\n                \n            >\n                <div [inner-template]=\"templateResultado || templateResultadoInterno\" [item]=\"item\"></div>\n            </li>\n        </ng-template>\n\n    ",
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return RequestMultipleComponent; }),
                            multi: true
                        }
                    ],
                    host: {
                        '(document:click)': 'clickForaComponent($event)',
                        '(focus)': 'setFocus(true)',
                        '(blur)': 'setFocus(false)',
                    },
                },] },
    ];
    /** @nocollapse */
    RequestMultipleComponent.ctorParameters = function () {
        return [
            { type: core.ElementRef, },
            { type: core.NgZone, },
            { type: SelectService, },
            { type: core.Renderer, },
        ];
    };
    RequestMultipleComponent.propDecorators = {
        "name": [{ type: core.Input },],
        "classe": [{ type: core.Input },],
        "placeholder": [{ type: core.Input },],
        "minimoCaracteres": [{ type: core.Input },],
        "templateResultado": [{ type: core.Input },],
        "templateLista": [{ type: core.Input },],
        "templateSelecionado": [{ type: core.Input },],
        "templateSemResultado": [{ type: core.Input },],
        "templateBuscando": [{ type: core.Input },],
        "disabled": [{ type: core.Input },],
        "indiceId": [{ type: core.Input },],
        "indiceNome": [{ type: core.Input },],
        "url": [{ type: core.Input },],
        "change": [{ type: core.Output },],
        "onSelecionarItem": [{ type: core.Output },],
        "onBuscar": [{ type: core.Output },],
        "onApagar": [{ type: core.Output },],
        "onRemoverItem": [{ type: core.Output },],
        "onAbrir": [{ type: core.Output },],
        "onFechar": [{ type: core.Output },],
        "onLimpar": [{ type: core.Output },],
        "onErro": [{ type: core.Output },],
        "onProcessaResultado": [{ type: core.Output },],
        "onProcessaParametros": [{ type: core.Output },],
        "campoBusca": [{ type: core.ViewChild, args: ['campoBusca',] },],
        "value": [{ type: core.Input },],
    };
    var SelectComponent = (function (_super) {
        tslib.__extends(SelectComponent, _super);
        /**
         * @param {?} elementRef
         * @param {?} zone
         */
        function SelectComponent(elementRef, zone) {
            var _this = _super.call(this, elementRef, zone) || this;
            _this.elementRef = elementRef;
            _this.zone = zone;
            _this._valores = [];
            _this.name = '';
            _this.classe = '';
            _this.placeholder = 'Selecione';
            _this.minimoCaracteres = 0;
            _this.indiceId = 'id';
            _this.indiceNome = 'nome';
            _this.disabled = false;
            // @Output() change            = new EventEmitter<any>();
            _this.onSelecionarItem = new core.EventEmitter();
            _this.onBuscar = new core.EventEmitter();
            _this.onApagar = new core.EventEmitter();
            _this.onRemoverItem = new core.EventEmitter();
            _this.onAbrir = new core.EventEmitter();
            _this.onFechar = new core.EventEmitter();
            _this.onLimpar = new core.EventEmitter();
            return _this;
        }
        Object.defineProperty(SelectComponent.prototype, "valores", {
            /**
             * @param {?} valor
             * @return {?}
             */
            set: function (valor) {
                this._valores = valor;
                this.valoresExibir = valor;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        SelectComponent.prototype.abrir = function () {
            if (this.disabled) {
                return false;
            }
            if (this.aberto) {
                this.fechar();
            }
            else {
                this.aberto = true;
                this.campoBusca.nativeElement.focus();
                this.valorPesquisado = '';
                this.campoBusca.nativeElement.value = '';
                this.setFocus(true);
                this.onAbrir.emit(true);
                this.buscar();
            }
        };
        /**
         * @param {?} item
         * @return {?}
         */
        SelectComponent.prototype.selecionar = function (item) {
            this.data = item;
            _super.prototype.selecionar.call(this, item);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        SelectComponent.prototype.limpar = function (event) {
            event.stopPropagation();
            this.data = null;
            this.updateValue(null);
            this.onLimpar.emit(true);
            if (this.aberto) {
                this.fechar();
            }
            else {
                this.abrir();
            }
        };
        /**
         * @return {?}
         */
        SelectComponent.prototype.buscar = function () {
            var _this = this;
            if (this.validaCaracteresMinimo() == false) {
                return false;
            }
            this.onBuscar.emit(this.valorPesquisado);
            this.valoresExibir = this._valores.filter(function (item) { return item[_this.indiceNome].toString().toLocaleLowerCase().indexOf(_this.valorPesquisado.toString().toLocaleLowerCase()) !== -1; });
        };
        Object.defineProperty(SelectComponent.prototype, "value", {
            /**
             * @return {?}
             */
            get: function () { return this._value; },
            /**
             * @param {?} v
             * @return {?}
             */
            set: function (v) {
                if (v !== this._value) {
                    this._value = v;
                    this._onChangeCallback(v);
                }
            },
            enumerable: true,
            configurable: true
        });
        return SelectComponent;
    }(Select));
    SelectComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'select2-select',
                    template: "\n        <!--select simples-->\n        <span [ngClass]=\"getClassGeral()\" dir=\"ltr\" (click)=\"abrir()\">\n        <span class=\"selection\">\n            <!--simples-->\n            <span class=\"select2-selection select2-selection--single\" role=\"combobox\" aria-haspopup=\"true\" aria-expanded=\"false\" tabindex=\"0\">\n                <span class=\"select2-selection__rendered\">\n                    <span [hidden]=\"!data\" (click)=\"limpar($event)\" class=\"select2-selection__clear\">\u00D7</span>\n                    <span [hidden]=\"!data\" class=\"nao-fechar\" [inner-template]=\"templateSelecionado || templateSelecionadoInterno\" [item]=\"data\"></span>\n                    <span [hidden]=\"data\" [innerHtml]=\"placeholder\" class=\"select2-selection__placeholder\"></span>\n\n                </span>\n                <span class=\"select2-selection__arrow\" role=\"presentation\">\n                    <b role=\"presentation\"></b>\n                </span>\n            </span>\n        </span>\n        <span class=\"dropdown-wrapper\" aria-hidden=\"true\"></span>\n    </span>\n\n        <!--quando clicar campo-->\n        <div [hidden]=\"!aberto\">\n        <span class=\"select2-container select2-container--bootstrap select2-container--open\">\n            <span class=\"select2-dropdown select2-dropdown--below\" dir=\"ltr\" >\n                <span class=\"select2-search select2-search--dropdown\">\n                    <input (keyup)=\"keyup($event.target.value)\" #campoBusca placeholder=\"Digite algo\" autofocus class=\"select2-search__field\" type=\"search\" tabindex=\"0\" autocomplete=\"off\" autocorrect=\"off\" autocapitalize=\"off\" spellcheck=\"false\" role=\"textbox\">\n                </span>\n                <span class=\"select2-results\">\n                    <ul class=\"select2-results__options\" role=\"tree\"  aria-expanded=\"true\" aria-hidden=\"false\">\n                        <span [style.display]=\"(exibirMensagemCaracteresMinimo) ? 'none': ''\">\n                            <span [hidden]=\"!valoresExibir.length\" >\n                                <li *ngFor=\"let item of valoresExibir\" (click)=\"selecionar(item)\" class=\"select2-results__option\" highlight=\"select2-results__option--highlighted\" role=\"treeitem\" [attr.aria-selected]=\"((_value) && (item[indiceId] == _value[indiceId])) ? true : false\">\n                                    <span  [inner-template]=\"templateResultado || templateResultadoInterno\" [item]=\"item\"></span>\n                                </li>\n                            </span>\n                            <li [style.display]=\"(valoresExibir.length > 0) ? 'none' : ''\" class=\"select2-results__option select2-results__message\" aria-live=\"assertive\">\n                                <span  [inner-template]=\"templateSemResultado || templateSemResultadoInterno\" [item]=\"{pesquisa:valorPesquisado}\"></span>\n                            </li>\n                        </span>\n                        <li  [style.display]=\"(exibirMensagemCaracteresMinimo == false) ? 'none': ''\" class=\"select2-results__option select2-results__message\">\n                            Digite {{minimoCaracteres}} ou mais caracteres para realizar a busca\n                        </li>\n                    </ul>\n                </span>\n            </span>\n        </span>\n        </div>\n\n\n\n        <ng-template #templateSemResultadoInterno>\n            Nenhum resultado encontrado\n        </ng-template>\n        <ng-template #templateResultadoInterno let-valor>\n            {{valor[indiceNome]}}\n        </ng-template>\n        <ng-template #templateSelecionadoInterno let-valor>\n        <span *ngIf=\"valor\">\n            {{valor[indiceNome]}}\n        </span>\n        </ng-template>\n\n    ",
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return SelectComponent; }),
                            multi: true
                        }
                    ],
                    host: {
                        '(document:click)': 'clickForaComponent($event)',
                        '(focus)': 'setFocus(true)',
                        '(blur)': 'setFocus(false)',
                    },
                },] },
    ];
    /** @nocollapse */
    SelectComponent.ctorParameters = function () {
        return [
            { type: core.ElementRef, },
            { type: core.NgZone, },
        ];
    };
    SelectComponent.propDecorators = {
        "name": [{ type: core.Input },],
        "classe": [{ type: core.Input },],
        "placeholder": [{ type: core.Input },],
        "minimoCaracteres": [{ type: core.Input },],
        "templateResultado": [{ type: core.Input },],
        "templateSelecionado": [{ type: core.Input },],
        "templateSemResultado": [{ type: core.Input },],
        "indiceId": [{ type: core.Input },],
        "indiceNome": [{ type: core.Input },],
        "disabled": [{ type: core.Input },],
        "valores": [{ type: core.Input },],
        "onSelecionarItem": [{ type: core.Output },],
        "onBuscar": [{ type: core.Output },],
        "onApagar": [{ type: core.Output },],
        "onRemoverItem": [{ type: core.Output },],
        "onAbrir": [{ type: core.Output },],
        "onFechar": [{ type: core.Output },],
        "onLimpar": [{ type: core.Output },],
        "campoBusca": [{ type: core.ViewChild, args: ['campoBusca',] },],
        "value": [{ type: core.Input },],
    };
    var TagComponent = (function (_super) {
        tslib.__extends(TagComponent, _super);
        /**
         * @param {?} elementRef
         * @param {?} zone
         */
        function TagComponent(elementRef, zone) {
            var _this = _super.call(this, elementRef, zone) || this;
            _this.elementRef = elementRef;
            _this.zone = zone;
            _this.data = [];
            _this._valores = [];
            _this.name = '';
            _this.classe = '';
            _this.placeholder = 'Selecione';
            _this.disabled = false;
            _this.change = new core.EventEmitter();
            _this.onSelecionarItem = new core.EventEmitter();
            _this.onBuscar = new core.EventEmitter();
            _this.onApagar = new core.EventEmitter();
            _this.onRemoverItem = new core.EventEmitter();
            _this.onAbrir = new core.EventEmitter();
            _this.onFechar = new core.EventEmitter();
            _this.onLimpar = new core.EventEmitter();
            return _this;
        }
        Object.defineProperty(TagComponent.prototype, "valores", {
            /**
             * @param {?} valor
             * @return {?}
             */
            set: function (valor) {
                this._valores = valor;
                this.valoresExibir = valor;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        TagComponent.prototype.abrir = function () {
            if (this.disabled) {
                return false;
            }
            if (this.aberto) {
                this.fechar();
            }
            else {
                this.aberto = true;
                if (!this._value) {
                    this._value = [];
                }
                this.valorPesquisado = '';
                this.campoBusca.nativeElement.focus();
                this.setFocus(true);
                this.onAbrir.emit(true);
                this.buscar();
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        TagComponent.prototype.keyup = function (event) {
            event.preventDefault();
            var /** @type {?} */ valor = event.target.value;
            //enter
            if (event.keyCode == 13) {
                this.selecionar(valor, false);
                this.valorPesquisado = '';
                this.buscar();
                return;
            }
            //apagar
            if (event.keyCode == 8) {
                this.remove(this.data[this.data.length - 1], event);
                this.valorPesquisado = '';
                this.buscar();
                event.preventDefault();
                return;
            }
            if (this.valorPesquisado == valor) {
                return null;
            }
            this.valoresExibir = [];
            this.valorPesquisado = valor;
            this.buscar();
        };
        /**
         * @param {?} item
         * @param {?=} fecharCampo
         * @return {?}
         */
        TagComponent.prototype.selecionar = function (item, fecharCampo) {
            if (fecharCampo === void 0) {
                fecharCampo = true;
            }
            item = item.trim();
            if (item == '') {
                return false;
            }
            //verifica se ja foi adicionado
            var /** @type {?} */ jaExiste = this.data.findIndex(function (procurar) { return procurar == item; });
            if (jaExiste === -1) {
                this.data.push(item);
            }
            this.updateValue(this.data);
            this.onSelecionarItem.emit(item);
            if (fecharCampo) {
                this.fechar();
            }
            //apaga campo de busca
            this.campoBusca.nativeElement.value = '';
        };
        /**
         * @param {?} event
         * @return {?}
         */
        TagComponent.prototype.limpar = function (event) {
            event.stopPropagation();
            this.data = [];
            this.updateValue(null);
            this.onLimpar.emit(true);
            this.aberto = false;
            this.abrir();
        };
        /**
         * @param {?} item
         * @param {?} event
         * @return {?}
         */
        TagComponent.prototype.remove = function (item, event) {
            event.stopPropagation();
            // this.fechar();
            // let itens
            var /** @type {?} */ posicao = this.data.findIndex(function (procurar) { return procurar == item; });
            if (posicao !== -1) {
                this.data.splice(posicao, 1);
            }
            this.onRemoverItem.emit(item);
            // if(this.data.length == 0){
            //     this.aberto = false;
            //     this.abrir();
            // }
            this.updateValue(this.data);
        };
        /**
         * @return {?}
         */
        TagComponent.prototype.buscar = function () {
            var _this = this;
            if (this.validaCaracteresMinimo() == false) {
                return false;
            }
            this.onBuscar.emit(this.valorPesquisado);
            this.valoresExibir = this._valores.filter(function (item) {
                var /** @type {?} */ pesquisa = item.toString().toLocaleLowerCase().indexOf(_this.valorPesquisado.toString().toLocaleLowerCase());
                //verifica se o item da lista original ja n esta add na lista data
                var /** @type {?} */ jaFoiAdicionado = _this.data.findIndex(function (procurar) { return procurar == item; });
                if (pesquisa !== -1 && jaFoiAdicionado === -1) {
                    return item;
                }
            });
        };
        Object.defineProperty(TagComponent.prototype, "value", {
            /**
             * @return {?}
             */
            get: function () { return this._value; },
            /**
             * @param {?} v
             * @return {?}
             */
            set: function (v) {
                if (v !== this._value) {
                    this._value = (v);
                    this._onChangeCallback(v);
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} value
         * @return {?}
         */
        TagComponent.prototype.writeValue = function (value) {
            if (!Array.isArray(value)) {
                value = [];
            }
            this.data = value;
            this._value = value;
        };
        /**
         * @param {?} value
         * @return {?}
         */
        TagComponent.prototype.updateValue = function (value) {
            var _this = this;
            this.zone.run(function () {
                _this._value = value;
                _this.onChange(value);
                _this._onTouchedCallback();
                _this.change.emit(value);
            });
        };
        /**
         * @param {?} _
         * @return {?}
         */
        TagComponent.prototype.onChange = function (_) { };
        /**
         * @return {?}
         */
        TagComponent.prototype.onTouched = function () { };
        /**
         * @param {?} fn
         * @return {?}
         */
        TagComponent.prototype.registerOnChange = function (fn) { this.onChange = fn; };
        /**
         * @param {?} fn
         * @return {?}
         */
        TagComponent.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
        /**
         * @param {?} _
         * @return {?}
         */
        TagComponent.prototype._onChangeCallback = function (_) { };
        /**
         * @return {?}
         */
        TagComponent.prototype._onTouchedCallback = function () { };
        return TagComponent;
    }(Select));
    TagComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'select2-tag',
                    template: "\n        <!--select simples-->\n        <span [ngClass]=\"getClassGeral()\" dir=\"ltr\" (click)=\"abrir()\">\n        <span class=\"selection\">\n            <span class=\"select2-selection select2-selection--multiple\" role=\"combobox\" aria-haspopup=\"true\" aria-expanded=\"false\" tabindex=\"-1\">\n            <ul class=\"select2-selection__rendered\">\n                <span [hidden]=\"data.length == 0\" >\n                    <span [inner-template]=\"templateSelecionado || templateSelecionadoInterno\" [item]=\"this\"></span>\n                </span>\n                <li class=\"select2-search select2-search--inline\" style=\"float:none\">\n                    <input (keyup)=\"keyup($event)\" (keydown.enter)=\"$event.preventDefault()\" #campoBusca class=\"select2-search__field\" type=\"search\" tabindex=\"0\" autocomplete=\"off\" autocorrect=\"off\" autocapitalize=\"off\" spellcheck=\"false\" role=\"textbox\" [placeholder]=\"(data.length == 0) ? placeholder : ''\">\n                </li>\n                <li class=\"select2-selection__arrow\" role=\"presentation\"><b role=\"presentation\"></b></li>\n            </ul>\n        </span>\n        </span>\n        <span class=\"dropdown-wrapper\" aria-hidden=\"true\"></span>\n    </span>\n\n        <!--quando clicar campo-->\n        <div [hidden]=\"!aberto\">\n        <span class=\"select2-container select2-container--bootstrap select2-container--open\">\n            <span class=\"select2-dropdown select2-dropdown--below\" style=\"z-index: 999999\" dir=\"ltr\" >\n                <span class=\"select2-results\">\n                    <ul class=\"select2-results__options\" role=\"tree\"  aria-expanded=\"true\" aria-hidden=\"false\">\n                        <span [style.display]=\"(exibirMensagemCaracteresMinimo) ? 'none': ''\">\n                            <span [hidden]=\"valoresExibir.length == 0\" >\n                                <li *ngFor=\"let item of valoresExibir\" (click)=\"selecionar(item)\" class=\"select2-results__option\" highlight=\"select2-results__option--highlighted\" role=\"treeitem\" [attr.aria-selected]=\"((_value) && (item == _value)) ? true : false\">\n                                    <span  [inner-template]=\"templateResultado || templateResultadoInterno\" [item]=\"item\"></span>\n                                </li>\n                            </span>\n                            <li [style.display]=\"(valoresExibir.length > 0) ? 'none' : ''\"  class=\"select2-results__option select2-results__message\" aria-live=\"assertive\">\n                                <span  [inner-template]=\"templateSemResultado || templateSemResultadoInterno\" [item]=\"{pesquisa:valorPesquisado}\"></span>\n                            </li>\n                        </span>\n                        <li [style.display]=\"(exibirMensagemCaracteresMinimo == false) ? 'none': ''\" class=\"select2-results__option select2-results__message\">\n                            Digite {{minimoCaracteres}} ou mais caracteres para realizar a busca\n                        </li>\n                    </ul>\n                </span>\n            </span>\n        </span>\n        </div>\n\n\n\n        <ng-template #templateSemResultadoInterno>\n            Nenhum resultado encontrado\n        </ng-template>\n        <ng-template #templateResultadoInterno let-valor>\n            {{valor}}\n        </ng-template>\n        <ng-template #templateSelecionadoInterno let-valor>\n        <span *ngIf=\"valor\">\n            <li *ngFor=\"let item of valor.data\" class=\"select2-selection__choice\">\n                <span class=\"select2-selection__choice__remove\" role=\"presentation\" (click)=\"valor.remove(item, $event)\">\u00D7</span>\n                {{item}}\n            </li>\n        </span>\n        </ng-template>\n    ",
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return TagComponent; }),
                            multi: true
                        }
                    ],
                    host: {
                        '(document:click)': 'clickForaComponent($event)',
                        '(focus)': 'setFocus(true)',
                        '(blur)': 'setFocus(false)',
                    },
                },] },
    ];
    /** @nocollapse */
    TagComponent.ctorParameters = function () {
        return [
            { type: core.ElementRef, },
            { type: core.NgZone, },
        ];
    };
    TagComponent.propDecorators = {
        "name": [{ type: core.Input },],
        "classe": [{ type: core.Input },],
        "placeholder": [{ type: core.Input },],
        "templateResultado": [{ type: core.Input },],
        "templateSelecionado": [{ type: core.Input },],
        "templateSemResultado": [{ type: core.Input },],
        "disabled": [{ type: core.Input },],
        "valores": [{ type: core.Input },],
        "change": [{ type: core.Output },],
        "onSelecionarItem": [{ type: core.Output },],
        "onBuscar": [{ type: core.Output },],
        "onApagar": [{ type: core.Output },],
        "onRemoverItem": [{ type: core.Output },],
        "onAbrir": [{ type: core.Output },],
        "onFechar": [{ type: core.Output },],
        "onLimpar": [{ type: core.Output },],
        "campoBusca": [{ type: core.ViewChild, args: ['campoBusca',] },],
        "value": [{ type: core.Input },],
    };
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var Ng2Select2BootstrapModule = (function () {
        function Ng2Select2BootstrapModule() {
        }
        return Ng2Select2BootstrapModule;
    }());
    Ng2Select2BootstrapModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                    ],
                    exports: [
                        InnerTemplateDirective,
                        SelectComponent,
                        MultipleComponent,
                        RequestComponent,
                        RequestMultipleComponent,
                        forms.FormsModule,
                        TagComponent,
                        HighlightDirective,
                    ],
                    declarations: [
                        InfiniteScrollDirective,
                        InnerTemplateDirective,
                        SelectComponent,
                        MultipleComponent,
                        RequestComponent,
                        HighlightDirective,
                        RequestMultipleComponent,
                        TagComponent,
                        HiddenDirective,
                    ],
                    providers: [SelectService]
                },] },
    ];

    exports.SelectService = SelectService;
    exports.HiddenDirective = HiddenDirective;
    exports.HighlightDirective = HighlightDirective;
    exports.InfiniteScrollDirective = InfiniteScrollDirective;
    exports.InnerTemplateDirective = InnerTemplateDirective;
    exports.MultipleComponent = MultipleComponent;
    exports.RequestComponent = RequestComponent;
    exports.RequestMultipleComponent = RequestMultipleComponent;
    exports.SelectComponent = SelectComponent;
    exports.TagComponent = TagComponent;
    exports.Select = Select;
    exports.Ng2Select2BootstrapModule = Ng2Select2BootstrapModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng2-select2-bootstrap.umd.js.map
