/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { EventEmitter } from "@angular/core";
export class Select {
    /**
     * @param {?} elementRef
     * @param {?} zone
     */
    constructor(elementRef, zone) {
        this.elementRef = elementRef;
        this.zone = zone;
        this.indiceId = 'id';
        this.indiceNome = 'nome';
        this.minimoCaracteres = 0;
        this.exibirMensagemCaracteresMinimo = true;
        this.aberto = false;
        this.focus = false;
        this.disabled = false;
        this.valoresExibir = [];
        this.change = new EventEmitter();
        this.onSelecionarItem = new EventEmitter();
        this.onBuscar = new EventEmitter();
        this.onApagar = new EventEmitter();
        this.onRemoverItem = new EventEmitter();
        this.onAbrir = new EventEmitter();
        this.onFechar = new EventEmitter();
        this.onLimpar = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (this.minimoCaracteres == 0) {
            this.exibirMensagemCaracteresMinimo = false;
        }
        this.elementRef.nativeElement.setAttribute("style", "float:left;width:100%");
    }
    /**
     * @param {?} valor
     * @return {?}
     */
    setFocus(valor) {
        if (this.disabled) {
            return false;
        }
        this.focus = valor;
    }
    /**
     * @return {?}
     */
    fechar() {
        this.aberto = false;
        this.valoresExibir = [];
        this.setFocus(true);
        this.setFocus(false);
        this.onFechar.emit(true);
    }
    /**
     * @param {?} item
     * @return {?}
     */
    selecionar(item) {
        this.updateValue(this.data);
        this.onSelecionarItem.emit(item);
        //apaga campo de busca
        this.campoBusca.nativeElement.value = '';
        this.fechar();
    }
    /**
     * @param {?} valor
     * @return {?}
     */
    keyup(valor) {
        if (this.valorPesquisado == valor) {
            return null;
        }
        this.valoresExibir = [];
        this.valorPesquisado = valor;
        this.buscar();
    }
    /**
     * @return {?}
     */
    buscar() {
    }
    /**
     * @return {?}
     */
    abrir() {
    }
    /**
     * quando está marcado para exibir resultado completo
     * @param {?} item
     * @param {?} event
     * @return {?}
     */
    remove(item, event) {
        event.stopPropagation();
        this.fechar();
        // let itens
        let /** @type {?} */ posicao = this.data.findIndex(procurar => procurar[this.indiceId] == item[this.indiceId]);
        if (posicao !== -1) {
            this.data.splice(posicao, 1);
        }
        this.onRemoverItem.emit(item);
        if (this.data.length == 0) {
            this.aberto = false;
            this.abrir();
        }
    }
    /**
     * @return {?}
     */
    getClassGeral() {
        return {
            'select2-container--focus': this.focus,
            'select2 select2-container select2-container--bootstrap select2-container--above': true,
            'select2-container--disabled': this.disabled
        };
    }
    /**
     * @param {?} event
     * @return {?}
     */
    clickForaComponent(event) {
        if (!this.elementRef.nativeElement.contains(event.target) && this.aberto) {
            this.fechar();
        }
    }
    /**
     * @return {?}
     */
    validaCaracteresMinimo() {
        if (this.minimoCaracteres > 0) {
            if (this.valorPesquisado.length < this.minimoCaracteres) {
                return false;
            }
            this.exibirMensagemCaracteresMinimo = false;
        }
        return true;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    writeValue(value) {
        this.data = value;
        this._value = value;
        this.updateValue(this._value);
    }
    /**
     * @param {?} value
     * @return {?}
     */
    updateValue(value) {
        this.zone.run(() => {
            if (this._value != value) {
                this._value = value;
                this.onChange(value);
                this._onTouchedCallback();
                // this.change.emit(value);
            }
        });
    }
    /**
     * @param {?} _
     * @return {?}
     */
    onChange(_) { }
    /**
     * @return {?}
     */
    onTouched() { }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnChange(fn) { this.onChange = fn; }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnTouched(fn) { this.onTouched = fn; }
    /**
     * @param {?} _
     * @return {?}
     */
    _onChangeCallback(_) { }
    /**
     * @return {?}
     */
    _onTouchedCallback() { }
}
function Select_tsickle_Closure_declarations() {
    /** @type {?} */
    Select.prototype.indiceId;
    /** @type {?} */
    Select.prototype.indiceNome;
    /** @type {?} */
    Select.prototype.minimoCaracteres;
    /** @type {?} */
    Select.prototype.exibirMensagemCaracteresMinimo;
    /** @type {?} */
    Select.prototype.aberto;
    /** @type {?} */
    Select.prototype.focus;
    /** @type {?} */
    Select.prototype.disabled;
    /** @type {?} */
    Select.prototype.campoBusca;
    /** @type {?} */
    Select.prototype.templateResultado;
    /** @type {?} */
    Select.prototype.templateSelecionado;
    /** @type {?} */
    Select.prototype.templateSemResultado;
    /** @type {?} */
    Select.prototype.templateBuscando;
    /** @type {?} */
    Select.prototype._value;
    /** @type {?} */
    Select.prototype.valoresExibir;
    /** @type {?} */
    Select.prototype._valores;
    /** @type {?} */
    Select.prototype.valorPesquisado;
    /** @type {?} */
    Select.prototype.data;
    /** @type {?} */
    Select.prototype.change;
    /** @type {?} */
    Select.prototype.onSelecionarItem;
    /** @type {?} */
    Select.prototype.onBuscar;
    /** @type {?} */
    Select.prototype.onApagar;
    /** @type {?} */
    Select.prototype.onRemoverItem;
    /** @type {?} */
    Select.prototype.onAbrir;
    /** @type {?} */
    Select.prototype.onFechar;
    /** @type {?} */
    Select.prototype.onLimpar;
    /** @type {?} */
    Select.prototype.elementRef;
    /** @type {?} */
    Select.prototype.zone;
}
//# sourceMappingURL=select.js.map
