/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Component, Input, ElementRef, forwardRef, NgZone, Output, EventEmitter, TemplateRef, ViewChild } from '@angular/core';
import { Select } from './../common/select';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
export class MultipleComponent extends Select {
    /**
     * @param {?} elementRef
     * @param {?} zone
     */
    constructor(elementRef, zone) {
        super(elementRef, zone);
        this.elementRef = elementRef;
        this.zone = zone;
        this.name = '';
        this.classe = '';
        this.placeholder = 'Selecione';
        this.minimoCaracteres = 0;
        this.disabled = false;
        this.indiceId = 'id';
        this.indiceNome = 'nome';
        this.change = new EventEmitter();
        this.onSelecionarItem = new EventEmitter();
        this.onBuscar = new EventEmitter();
        this.onApagar = new EventEmitter();
        this.onRemoverItem = new EventEmitter();
        this.onAbrir = new EventEmitter();
        this.onFechar = new EventEmitter();
        this.onLimpar = new EventEmitter();
    }
    /**
     * @param {?} valor
     * @return {?}
     */
    set valores(valor) {
        this._valores = valor;
        this.valoresExibir = valor;
    }
    /**
     * @return {?}
     */
    abrir() {
        if (this.disabled) {
            return false;
        }
        if (this.aberto) {
            this.fechar();
        }
        else {
            this.aberto = true;
            if (!this.data) {
                this.data = [];
            }
            if (!this._value) {
                this._value = [];
            }
            this.valorPesquisado = '';
            this.campoBusca.nativeElement.focus();
            this.setFocus(true);
            this.onAbrir.emit(true);
            this.buscar();
        }
    }
    /**
     * @param {?} item
     * @return {?}
     */
    selecionar(item) {
        //verifica se ja foi adicionado
        let /** @type {?} */ jaExiste = this.data.findIndex(procurar => procurar[this.indiceId] == item[this.indiceId]);
        if (jaExiste === -1) {
            this.data.push(item);
        }
        this.updateValue(this.data);
        this.onSelecionarItem.emit(item);
        this.fechar();
        //apaga campo de busca
        this.campoBusca.nativeElement.value = '';
    }
    /**
     * @return {?}
     */
    getSomenteId() {
        let /** @type {?} */ ids = [];
        for (let /** @type {?} */ item of this.data) {
            ids.push(item[this.indiceId]);
        }
        return ids;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    limpar(event) {
        event.stopPropagation();
        this.data = null;
        this.updateValue(null);
        this.onLimpar.emit(true);
        this.aberto = false;
        this.abrir();
    }
    /**
     * @param {?} item
     * @param {?} event
     * @return {?}
     */
    remove(item, event) {
        super.remove(item, event);
        this.updateValue(this.data);
    }
    /**
     * @return {?}
     */
    buscar() {
        if (this.validaCaracteresMinimo() == false) {
            return false;
        }
        this.onBuscar.emit(this.valorPesquisado);
        this.valoresExibir = this._valores.filter(item => {
            let /** @type {?} */ pesquisa = item[this.indiceNome].toString().toLocaleLowerCase().indexOf(this.valorPesquisado.toString().toLocaleLowerCase());
            //verifica se o item da lista original ja n esta add na lista data
            let /** @type {?} */ jaFoiAdicionado = this.data.findIndex(procurar => procurar[this.indiceId] == item[this.indiceId]);
            if (pesquisa !== -1 && jaFoiAdicionado === -1) {
                return item;
            }
        });
    }
    /**
     * @return {?}
     */
    get value() { return this._value; }
    ;
    /**
     * @param {?} v
     * @return {?}
     */
    set value(v) {
        if (v !== this._value) {
            this._value = (v);
            this._onChangeCallback(v);
        }
    }
    /**
     * @param {?} value
     * @return {?}
     */
    writeValue(value) {
        this.data = value;
        this._value = value;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    updateValue(value) {
        this.zone.run(() => {
            this._value = value;
            this.onChange(value);
            this._onTouchedCallback();
            this.change.emit(value);
        });
    }
    /**
     * @param {?} _
     * @return {?}
     */
    onChange(_) { }
    /**
     * @return {?}
     */
    onTouched() { }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnChange(fn) { this.onChange = fn; }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnTouched(fn) { this.onTouched = fn; }
    /**
     * @param {?} _
     * @return {?}
     */
    _onChangeCallback(_) { }
    /**
     * @return {?}
     */
    _onTouchedCallback() { }
}
MultipleComponent.decorators = [
    { type: Component, args: [{
                selector: 'select2-multiple',
                template: `
        <!--select simples-->
        <span [ngClass]="getClassGeral()" dir="ltr" (click)="abrir()">
        <span class="selection">
            <span class="select2-selection select2-selection--multiple" role="combobox" aria-haspopup="true" aria-expanded="false" tabindex="-1">
            <ul class="select2-selection__rendered">
                <li [hidden]="data" [innerHtml]="placeholder"  class="select2-selection__placeholder"></li>
                <span [hidden]="!data" >
                    <span [inner-template]="templateSelecionado || templateSelecionadoInterno" [item]="this"></span>
                </span>
                <li class="select2-selection__arrow" role="presentation"><b role="presentation"></b></li>
            </ul>
        </span>
        </span>
        <span class="dropdown-wrapper" aria-hidden="true"></span>
    </span>

        <!--quando clicar campo-->
        <div [hidden]="!aberto">
        <span class="select2-container select2-container--bootstrap select2-container--open">
            <span class="select2-dropdown select2-dropdown--below" dir="ltr" >
                <span class="select2-search select2-search--dropdown">
                    <input (keyup)="keyup($event.target.value)" #campoBusca placeholder="Digite algo" autofocus class="select2-search__field" type="search" tabindex="0" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false" role="textbox">
                </span>
                <span class="select2-results">
                    <ul class="select2-results__options" role="tree"  aria-expanded="true" aria-hidden="false">
                        <span [hidden]="exibirMensagemCaracteresMinimo">
                            <span [hidden]="valoresExibir.length == 0" >
                                <li *ngFor="let item of valoresExibir" (click)="selecionar(item)" class="select2-results__option" highlight="select2-results__option--highlighted" role="treeitem" [attr.aria-selected]="((_value) && (item[indiceId] == _value[indiceId])) ? true : false">
                                    <span  [inner-template]="templateResultado || templateResultadoInterno" [item]="item"></span>
                                </li>
                            </span>
                            <li [hidden]="valoresExibir.length > 0" class="select2-results__option select2-results__message" aria-live="assertive">
                                <span  [inner-template]="templateSemResultado || templateSemResultadoInterno" [item]="{pesquisa:valorPesquisado}"></span>
                            </li>
                        </span>
                        <li [hidden]="exibirMensagemCaracteresMinimo == false" class="select2-results__option select2-results__message">
                            Digite {{minimoCaracteres}} ou mais caracteres para realizar a busca
                        </li>
                    </ul>
                </span>
            </span>
        </span>
        </div>



        <ng-template #templateSemResultadoInterno>
            Nenhum resultado encontrado
        </ng-template>
        <ng-template #templateResultadoInterno let-valor>
            {{valor[indiceNome]}}
        </ng-template>
        <ng-template #templateSelecionadoInterno let-valor>
        <span *ngIf="valor">
            <li *ngFor="let item of valor.data" class="select2-selection__choice">
                <span class="select2-selection__choice__remove" role="presentation" (click)="valor.remove(item, $event)">×</span>
                {{item[indiceNome]}}
            </li>
        </span>
        </ng-template>
    `,
                providers: [
                    {
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: forwardRef(() => MultipleComponent),
                        multi: true
                    }
                ],
                host: {
                    '(document:click)': 'clickForaComponent($event)',
                    '(focus)': 'setFocus(true)',
                    '(blur)': 'setFocus(false)',
                },
            },] },
];
/** @nocollapse */
MultipleComponent.ctorParameters = () => [
    { type: ElementRef, },
    { type: NgZone, },
];
MultipleComponent.propDecorators = {
    "name": [{ type: Input },],
    "classe": [{ type: Input },],
    "placeholder": [{ type: Input },],
    "minimoCaracteres": [{ type: Input },],
    "templateResultado": [{ type: Input },],
    "templateSelecionado": [{ type: Input },],
    "templateSemResultado": [{ type: Input },],
    "disabled": [{ type: Input },],
    "indiceId": [{ type: Input },],
    "indiceNome": [{ type: Input },],
    "valores": [{ type: Input },],
    "change": [{ type: Output },],
    "onSelecionarItem": [{ type: Output },],
    "onBuscar": [{ type: Output },],
    "onApagar": [{ type: Output },],
    "onRemoverItem": [{ type: Output },],
    "onAbrir": [{ type: Output },],
    "onFechar": [{ type: Output },],
    "onLimpar": [{ type: Output },],
    "campoBusca": [{ type: ViewChild, args: ['campoBusca',] },],
    "value": [{ type: Input },],
};
function MultipleComponent_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    MultipleComponent.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    MultipleComponent.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    MultipleComponent.propDecorators;
    /** @type {?} */
    MultipleComponent.prototype.name;
    /** @type {?} */
    MultipleComponent.prototype.classe;
    /** @type {?} */
    MultipleComponent.prototype.placeholder;
    /** @type {?} */
    MultipleComponent.prototype.minimoCaracteres;
    /** @type {?} */
    MultipleComponent.prototype.templateResultado;
    /** @type {?} */
    MultipleComponent.prototype.templateSelecionado;
    /** @type {?} */
    MultipleComponent.prototype.templateSemResultado;
    /** @type {?} */
    MultipleComponent.prototype.disabled;
    /** @type {?} */
    MultipleComponent.prototype.indiceId;
    /** @type {?} */
    MultipleComponent.prototype.indiceNome;
    /** @type {?} */
    MultipleComponent.prototype.change;
    /** @type {?} */
    MultipleComponent.prototype.onSelecionarItem;
    /** @type {?} */
    MultipleComponent.prototype.onBuscar;
    /** @type {?} */
    MultipleComponent.prototype.onApagar;
    /** @type {?} */
    MultipleComponent.prototype.onRemoverItem;
    /** @type {?} */
    MultipleComponent.prototype.onAbrir;
    /** @type {?} */
    MultipleComponent.prototype.onFechar;
    /** @type {?} */
    MultipleComponent.prototype.onLimpar;
    /** @type {?} */
    MultipleComponent.prototype.campoBusca;
    /** @type {?} */
    MultipleComponent.prototype.elementRef;
    /** @type {?} */
    MultipleComponent.prototype.zone;
}
//# sourceMappingURL=multiple.component.js.map
