/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Component, Input, ElementRef, forwardRef, NgZone, Output, EventEmitter, TemplateRef, ViewChild, Renderer } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { Select } from './../common/select';
import { SelectService } from '../service/select.service';
export class RequestMultipleComponent extends Select {
    /**
     * @param {?} elementRef
     * @param {?} zone
     * @param {?} requisicao
     * @param {?} renderer
     */
    constructor(elementRef, zone, requisicao, renderer) {
        super(elementRef, zone);
        this.elementRef = elementRef;
        this.zone = zone;
        this.requisicao = requisicao;
        this.renderer = renderer;
        this.name = '';
        this.classe = '';
        this.placeholder = 'Selecione';
        this.minimoCaracteres = 0;
        this.disabled = false;
        this.indiceId = 'id';
        this.indiceNome = 'nome';
        this.change = new EventEmitter();
        this.onSelecionarItem = new EventEmitter();
        this.onBuscar = new EventEmitter();
        this.onApagar = new EventEmitter();
        this.onRemoverItem = new EventEmitter();
        this.onAbrir = new EventEmitter();
        this.onFechar = new EventEmitter();
        this.onLimpar = new EventEmitter();
        this.onErro = new EventEmitter();
        this.onProcessaResultado = new EventEmitter();
        this.onProcessaParametros = new EventEmitter();
        this.pagina = 1;
        this.quantidadePadrao = 0;
        this.buscando = false;
        this.semResultado = false;
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this.subscrebeBusca) {
            this.subscrebeBusca.unsubscribe();
        }
    }
    /**
     * @return {?}
     */
    abrir() {
        if (this.disabled) {
            return false;
        }
        if (this.aberto) {
            this.fechar();
        }
        else {
            this.aberto = true;
            if (!this.data) {
                this.data = [];
            }
            this.onAbrir.emit(true);
            // this.renderer.invokeElementMethod(this.campoBusca.nativeElement, 'focus', []);
            this.pagina = 1;
            this.semResultado = false;
            this.quantidadePadrao = 0;
            this.valorPesquisado = '';
            this.campoBusca.nativeElement.value = '';
            this.setFocus(true);
            this.buscar();
        }
    }
    /**
     * @param {?} valor
     * @return {?}
     */
    keyup(valor) {
        if (this.valorPesquisado == valor) {
            return null;
        }
        this.valoresExibir = [];
        this.valorPesquisado = valor;
        this.pagina = 1;
        this.buscar();
    }
    /**
     * @param {?} item
     * @return {?}
     */
    selecionar(item) {
        let /** @type {?} */ jaExiste = this.data.findIndex(procurar => procurar[this.indiceId] == item[this.indiceId]);
        if (jaExiste === -1) {
            this.data.push(item);
        }
        this.updateValue(this.data);
        this.onSelecionarItem.emit(item);
        this.fechar();
        //apaga campo de busca
        this.campoBusca.nativeElement.value = '';
    }
    /**
     * @return {?}
     */
    getSomenteId() {
        let /** @type {?} */ ids = [];
        for (let /** @type {?} */ item of this.data) {
            ids.push(item[this.indiceId]);
        }
        return ids;
    }
    /**
     * @return {?}
     */
    limpar() {
        this.data = [];
        this.updateValue(null);
        this.aberto = false;
        this.onLimpar.emit(true);
        this.abrir();
    }
    /**
     * @return {?}
     */
    buscar() {
        if (this.validaCaracteresMinimo() == false) {
            return false;
        }
        this.buscando = true;
        // this.valoresExibir = this._valores.filter(item => item[this.indiceNome].indexOf(this.valorPesquisado) !== -1);
        let /** @type {?} */ parametros = {
            enviado: {
                pagina: this.pagina,
                valorPesquisado: this.valorPesquisado,
                idSelecionados: this.getSomenteId(),
            },
            retorno: {}
        };
        //mata o subscribe
        this.ngOnDestroy();
        this.onBuscar.emit(this.valorPesquisado);
        this.onProcessaParametros.emit(parametros);
        this.subscrebeBusca = this.requisicao.getResultados(this.url, parametros.retorno).subscribe(resultado => {
            let /** @type {?} */ objEmit = { enviado: resultado, retorno: [] };
            this.onProcessaResultado.emit(objEmit);
            let /** @type {?} */ exibirResultado = objEmit.retorno;
            if (Array.isArray(exibirResultado)) {
                if (this.quantidadePadrao == 0 && exibirResultado.length < 25) {
                    this.semResultado = true;
                }
                if (this.quantidadePadrao == 0) {
                    this.quantidadePadrao = exibirResultado.length;
                }
                if (this.quantidadePadrao != exibirResultado.length) {
                    this.semResultado = true;
                }
                this.valoresExibir = this.valoresExibir.concat(exibirResultado);
            }
            else {
                console.log('Ng2Select2Bootstrap: retorno não é um select', exibirResultado);
            }
            this.buscando = false;
        }, erro => {
            if (erro.status == 409) {
                this.semResultado = true;
            }
            this.onErro.emit(erro);
            this.buscando = false;
        });
    }
    /**
     * @return {?}
     */
    onScroll() {
        if (!this.buscando && !this.semResultado) {
            this.pagina++;
            this.buscar();
        }
    }
    /**
     * @return {?}
     */
    get value() { return this._value; }
    ;
    /**
     * @param {?} v
     * @return {?}
     */
    set value(v) {
        if (v !== this._value) {
            this._value = v;
            this._onChangeCallback(v);
        }
    }
}
RequestMultipleComponent.decorators = [
    { type: Component, args: [{
                selector: 'select2-request-multiple',
                template: `
        <span [ngClass]="getClassGeral()"  dir="ltr" (click)="abrir()">
        <span class="selection">
            <span class="select2-selection select2-selection--multiple" role="combobox" aria-haspopup="true" aria-expanded="false" tabindex="-1">
            <ul class="select2-selection__rendered">
                <li [hidden]="data" [innerHtml]="placeholder"  class="select2-selection__placeholder"></li>
                <span [hidden]="!data" >
                    <span [inner-template]="templateSelecionado || templateSelecionadoInterno" [item]="this"></span>
                </span>
                <li class="select2-selection__arrow" role="presentation"><b role="presentation"></b></li>
            </ul>
        </span>
        </span>
        <span class="dropdown-wrapper" aria-hidden="true"></span>
    </span>

        <!--quando clicar campo-->
        <div [hidden]="!aberto">
        <span class="select2-container select2-container--bootstrap select2-container--open">
            <span class="select2-dropdown select2-dropdown--below" style="z-index: 999999" dir="ltr" >
                <span class="select2-search select2-search--dropdown">
                    <input (keyup)="keyup($event.target.value)" #campoBusca placeholder="Digite algo" autofocus class="select2-search__field" type="search" tabindex="0" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false" role="textbox">
                </span>
                <span class="select2-results" aria-expanded="true" aria-hidden="false">
                    <ul
                            class="select2-results__options"
                            role="tree"
                            infinite-scroll
                            scroll-distance="0,30"
                            (OnScrollMethod)="onScroll()"
                            style=" overflow: auto!important;"
                    >
                        <div [style.display]="(exibirMensagemCaracteresMinimo) ? 'none': ''">
                            <span [style.display]="(valoresExibir.length == 0) ? 'none':''" >
                                <ng-template [inner-template]="templateLista || templateListaInterno" [item]="{component: this}"></ng-template>
                            </span>
                            <li [style.display]="(buscando || valoresExibir.length > 0) ? 'none' : ''" class="select2-results__option select2-results__message" aria-live="assertive">
                                <span  [inner-template]="templateSemResultado || templateSemResultadoInterno" [item]="{pesquisa:valorPesquisado}"></span>
                            </li>
                            <li [style.display]="(!buscando) ? 'none' : ''">
                                <span [inner-template]="templateBuscando || templateBuscandoInterno"></span>
                            </li>
                        </div>
                        <li [style.display]="(exibirMensagemCaracteresMinimo == false) ? 'none': ''" class="select2-results__option select2-results__message">
                            Digite {{minimoCaracteres}} ou mais caracteres para realizar a busca
                        </li>
                    </ul>
                </span>
            </span>
        </span>
        </div>



        <ng-template #templateSemResultadoInterno>
            Nenhum resultado encontrado
        </ng-template>
        <ng-template #templateResultadoInterno let-valor>
            {{valor[indiceNome]}}
        </ng-template>
        <ng-template #templateSelecionadoInterno let-valor>
       <span *ngIf="valor">
            <li *ngFor="let item of valor.data" class="select2-selection__choice">
                <span class="select2-selection__choice__remove" role="presentation" (click)="valor.remove(item, $event)">×</span>
                {{item[indiceNome]}}
            </li>
        </span>
        </ng-template>
        <ng-template #templateBuscandoInterno>
            <span class="fa fa-5x fa-refresh fa-spin" style=" width: auto;margin:auto 50% !important"></span>
        </ng-template>
         <ng-template #templateListaInterno let-valor>
            <li 
                *ngFor="let item of valor.component.valoresExibir" 
                (click)="valor.component.selecionar(item)" class="select2-results__option" 
                highlight="select2-results__option--highlighted" 
                role="treeitem" 
                [attr.aria-selected]="((_value) && (item[valor.component.indiceId] == _value[valor.component.indiceId])) ? true : false"
                
            >
                <div [inner-template]="templateResultado || templateResultadoInterno" [item]="item"></div>
            </li>
        </ng-template>

    `,
                providers: [
                    {
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: forwardRef(() => RequestMultipleComponent),
                        multi: true
                    }
                ],
                host: {
                    '(document:click)': 'clickForaComponent($event)',
                    '(focus)': 'setFocus(true)',
                    '(blur)': 'setFocus(false)',
                },
            },] },
];
/** @nocollapse */
RequestMultipleComponent.ctorParameters = () => [
    { type: ElementRef, },
    { type: NgZone, },
    { type: SelectService, },
    { type: Renderer, },
];
RequestMultipleComponent.propDecorators = {
    "name": [{ type: Input },],
    "classe": [{ type: Input },],
    "placeholder": [{ type: Input },],
    "minimoCaracteres": [{ type: Input },],
    "templateResultado": [{ type: Input },],
    "templateLista": [{ type: Input },],
    "templateSelecionado": [{ type: Input },],
    "templateSemResultado": [{ type: Input },],
    "templateBuscando": [{ type: Input },],
    "disabled": [{ type: Input },],
    "indiceId": [{ type: Input },],
    "indiceNome": [{ type: Input },],
    "url": [{ type: Input },],
    "change": [{ type: Output },],
    "onSelecionarItem": [{ type: Output },],
    "onBuscar": [{ type: Output },],
    "onApagar": [{ type: Output },],
    "onRemoverItem": [{ type: Output },],
    "onAbrir": [{ type: Output },],
    "onFechar": [{ type: Output },],
    "onLimpar": [{ type: Output },],
    "onErro": [{ type: Output },],
    "onProcessaResultado": [{ type: Output },],
    "onProcessaParametros": [{ type: Output },],
    "campoBusca": [{ type: ViewChild, args: ['campoBusca',] },],
    "value": [{ type: Input },],
};
function RequestMultipleComponent_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    RequestMultipleComponent.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    RequestMultipleComponent.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    RequestMultipleComponent.propDecorators;
    /** @type {?} */
    RequestMultipleComponent.prototype.name;
    /** @type {?} */
    RequestMultipleComponent.prototype.classe;
    /** @type {?} */
    RequestMultipleComponent.prototype.placeholder;
    /** @type {?} */
    RequestMultipleComponent.prototype.minimoCaracteres;
    /** @type {?} */
    RequestMultipleComponent.prototype.templateResultado;
    /** @type {?} */
    RequestMultipleComponent.prototype.templateLista;
    /** @type {?} */
    RequestMultipleComponent.prototype.templateSelecionado;
    /** @type {?} */
    RequestMultipleComponent.prototype.templateSemResultado;
    /** @type {?} */
    RequestMultipleComponent.prototype.templateBuscando;
    /** @type {?} */
    RequestMultipleComponent.prototype.disabled;
    /** @type {?} */
    RequestMultipleComponent.prototype.indiceId;
    /** @type {?} */
    RequestMultipleComponent.prototype.indiceNome;
    /** @type {?} */
    RequestMultipleComponent.prototype.url;
    /** @type {?} */
    RequestMultipleComponent.prototype.change;
    /** @type {?} */
    RequestMultipleComponent.prototype.onSelecionarItem;
    /** @type {?} */
    RequestMultipleComponent.prototype.onBuscar;
    /** @type {?} */
    RequestMultipleComponent.prototype.onApagar;
    /** @type {?} */
    RequestMultipleComponent.prototype.onRemoverItem;
    /** @type {?} */
    RequestMultipleComponent.prototype.onAbrir;
    /** @type {?} */
    RequestMultipleComponent.prototype.onFechar;
    /** @type {?} */
    RequestMultipleComponent.prototype.onLimpar;
    /** @type {?} */
    RequestMultipleComponent.prototype.onErro;
    /** @type {?} */
    RequestMultipleComponent.prototype.onProcessaResultado;
    /** @type {?} */
    RequestMultipleComponent.prototype.onProcessaParametros;
    /** @type {?} */
    RequestMultipleComponent.prototype.campoBusca;
    /** @type {?} */
    RequestMultipleComponent.prototype.pagina;
    /** @type {?} */
    RequestMultipleComponent.prototype.quantidadePadrao;
    /** @type {?} */
    RequestMultipleComponent.prototype.buscando;
    /** @type {?} */
    RequestMultipleComponent.prototype.semResultado;
    /** @type {?} */
    RequestMultipleComponent.prototype.subscrebeBusca;
    /** @type {?} */
    RequestMultipleComponent.prototype.elementRef;
    /** @type {?} */
    RequestMultipleComponent.prototype.zone;
    /** @type {?} */
    RequestMultipleComponent.prototype.requisicao;
    /** @type {?} */
    RequestMultipleComponent.prototype.renderer;
}
//# sourceMappingURL=request-multiple.component.js.map
