/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Directive, HostListener, ElementRef, Input } from "@angular/core";
export class HighlightDirective {
    /**
     * @param {?} elementRef
     */
    constructor(elementRef) {
        this.elementRef = elementRef;
    }
    /**
     * @return {?}
     */
    onMouseEnter() {
        this.highlight();
    }
    /**
     * @return {?}
     */
    onMouseLeave() {
        this.highlight();
    }
    /**
     * @return {?}
     */
    highlight() {
        if (this.elementRef.nativeElement.className.indexOf(this.classe) === -1) {
            this.elementRef.nativeElement.className += ' ' + this.classe;
        }
        else {
            this.elementRef.nativeElement.classList.remove(this.classe);
        }
    }
}
HighlightDirective.decorators = [
    { type: Directive, args: [{
                selector: '[highlight]',
            },] },
];
/** @nocollapse */
HighlightDirective.ctorParameters = () => [
    { type: ElementRef, },
];
HighlightDirective.propDecorators = {
    "classe": [{ type: Input, args: ['highlight',] },],
    "onMouseEnter": [{ type: HostListener, args: ['mouseenter',] },],
    "onMouseLeave": [{ type: HostListener, args: ['mouseleave',] },],
};
function HighlightDirective_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    HighlightDirective.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    HighlightDirective.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    HighlightDirective.propDecorators;
    /** @type {?} */
    HighlightDirective.prototype.classe;
    /** @type {?} */
    HighlightDirective.prototype.elementRef;
}
//# sourceMappingURL=highlight.directive.js.map
