/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Directive, ElementRef, Input, Output, EventEmitter } from '@angular/core';
export class InfiniteScrollDirective {
    /**
     * @param {?} element
     */
    constructor(element) {
        this.element = element;
        this._count = 0;
        this.OnScrollMethod = new EventEmitter();
        this._element = this.element.nativeElement;
        if (!this.scrollTrigger) {
            this.scrollTrigger = 1;
        }
    }
    /**
     * @return {?}
     */
    onScroll() {
        this._count++;
        if (this._element.scrollTop + this._element.clientHeight >= this._element.scrollHeight) {
            this.OnScrollMethod.emit(null);
        }
        else {
            if (this._element.scrollTop + this._element.clientHeight >= (this._element.scrollHeight - (this._element.scrollHeight * this.scrollTrigger))) {
                this.OnScrollMethod.emit(null);
            }
        }
    }
}
InfiniteScrollDirective.decorators = [
    { type: Directive, args: [{
                selector: '[infinite-scroll]',
                host: {
                    '(scroll)': 'onScroll($event)'
                }
            },] },
];
/** @nocollapse */
InfiniteScrollDirective.ctorParameters = () => [
    { type: ElementRef, },
];
InfiniteScrollDirective.propDecorators = {
    "scrollTrigger": [{ type: Input, args: ['scroll-distance',] },],
    "OnScrollMethod": [{ type: Output },],
};
function InfiniteScrollDirective_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    InfiniteScrollDirective.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    InfiniteScrollDirective.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    InfiniteScrollDirective.propDecorators;
    /** @type {?} */
    InfiniteScrollDirective.prototype._element;
    /** @type {?} */
    InfiniteScrollDirective.prototype._count;
    /** @type {?} */
    InfiniteScrollDirective.prototype.scrollTrigger;
    /** @type {?} */
    InfiniteScrollDirective.prototype.OnScrollMethod;
    /** @type {?} */
    InfiniteScrollDirective.prototype.element;
}
//# sourceMappingURL=infinite-scroll.directive.js.map
