/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Input, Directive, TemplateRef, ViewContainerRef } from "@angular/core";
export class InnerTemplateDirective {
    /**
     * @param {?} viewContainer
     */
    constructor(viewContainer) {
        this.viewContainer = viewContainer;
    }
    /**
     * @param {?} item
     * @return {?}
     */
    set item(item) {
        this._item = item;
        if (this.template) {
            this.template.destroy();
            this.criaTemplate();
        }
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.criaTemplate();
    }
    /**
     * @return {?}
     */
    criaTemplate() {
        if (this.templateRef) {
            this.template = this.viewContainer.createEmbeddedView(this.templateRef, {
                '\$implicit': this._item,
                'index': this.index
            });
        }
    }
}
InnerTemplateDirective.decorators = [
    { type: Directive, args: [{
                selector: '[inner-template]'
            },] },
];
/** @nocollapse */
InnerTemplateDirective.ctorParameters = () => [
    { type: ViewContainerRef, },
];
InnerTemplateDirective.propDecorators = {
    "item": [{ type: Input },],
    "index": [{ type: Input },],
    "templateRef": [{ type: Input, args: ['inner-template',] },],
};
function InnerTemplateDirective_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    InnerTemplateDirective.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    InnerTemplateDirective.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    InnerTemplateDirective.propDecorators;
    /** @type {?} */
    InnerTemplateDirective.prototype._item;
    /** @type {?} */
    InnerTemplateDirective.prototype.template;
    /** @type {?} */
    InnerTemplateDirective.prototype.index;
    /** @type {?} */
    InnerTemplateDirective.prototype.templateRef;
    /** @type {?} */
    InnerTemplateDirective.prototype.viewContainer;
}
//# sourceMappingURL=inner-template.directive.js.map
