/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/catch';
import 'rxjs/add/operator/toPromise';
import { HttpClient, HttpHeaders, HttpParams } from "@angular/common/http";
import { Injectable } from "@angular/core";
import * as i0 from "@angular/core";
import * as i1 from "@angular/common/http";
export class SelectService {
    /**
     * @param {?} http
     */
    constructor(http) {
        this.http = http;
        this.headers = new HttpHeaders({ 'Content-Type': 'application/json' });
    }
    /**
     * @param {?} url
     * @param {?} parametros
     * @return {?}
     */
    getResultados(url, parametros) {
        let /** @type {?} */ urlParams = this.paramns(parametros, new HttpParams());
        return this.http.get(url, { headers: this.headers, params: urlParams });
    }
    /**
     * @param {?} a
     * @param {?} urlParams
     * @return {?}
     */
    paramns(a, urlParams) {
        for (let /** @type {?} */ prefix in a) {
            urlParams = this.buildParams(prefix, a[prefix], urlParams);
        }
        return urlParams;
    }
    /**
     * @param {?} prefix
     * @param {?} obj
     * @param {?} urlParams
     * @return {?}
     */
    buildParams(prefix, obj, urlParams) {
        if (obj instanceof Array) {
            for (let /** @type {?} */ i in obj) {
                urlParams = this.buildParams(prefix + "[" + (typeof obj[i] === "object" || Array.isArray(obj[i]) ? i : "") + "]", obj[i], urlParams);
            }
            return urlParams;
        }
        else if (obj instanceof Object) {
            for (let /** @type {?} */ name in obj) {
                if (obj[name] instanceof Date) {
                    obj[name] = JSON.stringify(obj[name]);
                }
                urlParams = this.buildParams(prefix + "[" + name + "]", obj[name], urlParams);
            }
            return urlParams;
        }
        else {
            if (obj !== null && obj !== undefined) {
                urlParams = urlParams.append(prefix, obj);
            }
            return urlParams;
        }
    }
}
SelectService.decorators = [
    { type: Injectable, args: [{
                providedIn: "root"
            },] },
];
/** @nocollapse */
SelectService.ctorParameters = () => [
    { type: HttpClient, },
];
/** @nocollapse */ SelectService.ngInjectableDef = i0.defineInjectable({ factory: function SelectService_Factory() { return new SelectService(i0.inject(i1.HttpClient)); }, token: SelectService, providedIn: "root" });
function SelectService_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    SelectService.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    SelectService.ctorParameters;
    /** @type {?} */
    SelectService.prototype.headers;
    /** @type {?} */
    SelectService.prototype.http;
}
//# sourceMappingURL=select.service.js.map
