/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { EventEmitter } from "@angular/core";
var Select = /** @class */ (function () {
    /**
     * @param {?} elementRef
     * @param {?} zone
     */
    function Select(elementRef, zone) {
        this.elementRef = elementRef;
        this.zone = zone;
        this.indiceId = 'id';
        this.indiceNome = 'nome';
        this.minimoCaracteres = 0;
        this.exibirMensagemCaracteresMinimo = true;
        this.aberto = false;
        this.focus = false;
        this.disabled = false;
        this.valoresExibir = [];
        this.change = new EventEmitter();
        this.onSelecionarItem = new EventEmitter();
        this.onBuscar = new EventEmitter();
        this.onApagar = new EventEmitter();
        this.onRemoverItem = new EventEmitter();
        this.onAbrir = new EventEmitter();
        this.onFechar = new EventEmitter();
        this.onLimpar = new EventEmitter();
    }
    /**
     * @return {?}
     */
    Select.prototype.ngOnInit = function () {
        if (this.minimoCaracteres == 0) {
            this.exibirMensagemCaracteresMinimo = false;
        }
        this.elementRef.nativeElement.setAttribute("style", "float:left;width:100%");
    };
    /**
     * @param {?} valor
     * @return {?}
     */
    Select.prototype.setFocus = function (valor) {
        if (this.disabled) {
            return false;
        }
        this.focus = valor;
    };
    /**
     * @return {?}
     */
    Select.prototype.fechar = function () {
        this.aberto = false;
        this.valoresExibir = [];
        this.setFocus(true);
        this.setFocus(false);
        this.onFechar.emit(true);
    };
    /**
     * @param {?} item
     * @return {?}
     */
    Select.prototype.selecionar = function (item) {
        this.updateValue(this.data);
        this.onSelecionarItem.emit(item);
        //apaga campo de busca
        this.campoBusca.nativeElement.value = '';
        this.fechar();
    };
    /**
     * @param {?} valor
     * @return {?}
     */
    Select.prototype.keyup = function (valor) {
        if (this.valorPesquisado == valor) {
            return null;
        }
        this.valoresExibir = [];
        this.valorPesquisado = valor;
        this.buscar();
    };
    /**
     * @return {?}
     */
    Select.prototype.buscar = function () {
    };
    /**
     * @return {?}
     */
    Select.prototype.abrir = function () {
    };
    /**
     * quando está marcado para exibir resultado completo
     * @param {?} item
     * @param {?} event
     * @return {?}
     */
    Select.prototype.remove = function (item, event) {
        var _this = this;
        event.stopPropagation();
        this.fechar();
        // let itens
        var /** @type {?} */ posicao = this.data.findIndex(function (procurar) { return procurar[_this.indiceId] == item[_this.indiceId]; });
        if (posicao !== -1) {
            this.data.splice(posicao, 1);
        }
        this.onRemoverItem.emit(item);
        if (this.data.length == 0) {
            this.aberto = false;
            this.abrir();
        }
    };
    /**
     * @return {?}
     */
    Select.prototype.getClassGeral = function () {
        return {
            'select2-container--focus': this.focus,
            'select2 select2-container select2-container--bootstrap select2-container--above': true,
            'select2-container--disabled': this.disabled
        };
    };
    /**
     * @param {?} event
     * @return {?}
     */
    Select.prototype.clickForaComponent = function (event) {
        if (!this.elementRef.nativeElement.contains(event.target) && this.aberto) {
            this.fechar();
        }
    };
    /**
     * @return {?}
     */
    Select.prototype.validaCaracteresMinimo = function () {
        if (this.minimoCaracteres > 0) {
            if (this.valorPesquisado.length < this.minimoCaracteres) {
                return false;
            }
            this.exibirMensagemCaracteresMinimo = false;
        }
        return true;
    };
    /**
     * @param {?} value
     * @return {?}
     */
    Select.prototype.writeValue = function (value) {
        this.data = value;
        this._value = value;
        this.updateValue(this._value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    Select.prototype.updateValue = function (value) {
        var _this = this;
        this.zone.run(function () {
            if (_this._value != value) {
                _this._value = value;
                _this.onChange(value);
                _this._onTouchedCallback();
                // this.change.emit(value);
            }
        });
    };
    /**
     * @param {?} _
     * @return {?}
     */
    Select.prototype.onChange = function (_) { };
    /**
     * @return {?}
     */
    Select.prototype.onTouched = function () { };
    /**
     * @param {?} fn
     * @return {?}
     */
    Select.prototype.registerOnChange = function (fn) { this.onChange = fn; };
    /**
     * @param {?} fn
     * @return {?}
     */
    Select.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
    /**
     * @param {?} _
     * @return {?}
     */
    Select.prototype._onChangeCallback = function (_) { };
    /**
     * @return {?}
     */
    Select.prototype._onTouchedCallback = function () { };
    return Select;
}());
export { Select };
function Select_tsickle_Closure_declarations() {
    /** @type {?} */
    Select.prototype.indiceId;
    /** @type {?} */
    Select.prototype.indiceNome;
    /** @type {?} */
    Select.prototype.minimoCaracteres;
    /** @type {?} */
    Select.prototype.exibirMensagemCaracteresMinimo;
    /** @type {?} */
    Select.prototype.aberto;
    /** @type {?} */
    Select.prototype.focus;
    /** @type {?} */
    Select.prototype.disabled;
    /** @type {?} */
    Select.prototype.campoBusca;
    /** @type {?} */
    Select.prototype.templateResultado;
    /** @type {?} */
    Select.prototype.templateSelecionado;
    /** @type {?} */
    Select.prototype.templateSemResultado;
    /** @type {?} */
    Select.prototype.templateBuscando;
    /** @type {?} */
    Select.prototype._value;
    /** @type {?} */
    Select.prototype.valoresExibir;
    /** @type {?} */
    Select.prototype._valores;
    /** @type {?} */
    Select.prototype.valorPesquisado;
    /** @type {?} */
    Select.prototype.data;
    /** @type {?} */
    Select.prototype.change;
    /** @type {?} */
    Select.prototype.onSelecionarItem;
    /** @type {?} */
    Select.prototype.onBuscar;
    /** @type {?} */
    Select.prototype.onApagar;
    /** @type {?} */
    Select.prototype.onRemoverItem;
    /** @type {?} */
    Select.prototype.onAbrir;
    /** @type {?} */
    Select.prototype.onFechar;
    /** @type {?} */
    Select.prototype.onLimpar;
    /** @type {?} */
    Select.prototype.elementRef;
    /** @type {?} */
    Select.prototype.zone;
}
//# sourceMappingURL=select.js.map
