import * as tslib_1 from "tslib";
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Component, Input, ElementRef, forwardRef, NgZone, Output, EventEmitter, ViewChild } from '@angular/core';
import { Select } from './../common/select';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
var MultipleComponent = /** @class */ (function (_super) {
    tslib_1.__extends(MultipleComponent, _super);
    /**
     * @param {?} elementRef
     * @param {?} zone
     */
    function MultipleComponent(elementRef, zone) {
        var _this = _super.call(this, elementRef, zone) || this;
        _this.elementRef = elementRef;
        _this.zone = zone;
        _this.name = '';
        _this.classe = '';
        _this.placeholder = 'Selecione';
        _this.minimoCaracteres = 0;
        _this.disabled = false;
        _this.indiceId = 'id';
        _this.indiceNome = 'nome';
        _this.change = new EventEmitter();
        _this.onSelecionarItem = new EventEmitter();
        _this.onBuscar = new EventEmitter();
        _this.onApagar = new EventEmitter();
        _this.onRemoverItem = new EventEmitter();
        _this.onAbrir = new EventEmitter();
        _this.onFechar = new EventEmitter();
        _this.onLimpar = new EventEmitter();
        return _this;
    }
    Object.defineProperty(MultipleComponent.prototype, "valores", {
        /**
         * @param {?} valor
         * @return {?}
         */
        set: function (valor) {
            this._valores = valor;
            this.valoresExibir = valor;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    MultipleComponent.prototype.abrir = function () {
        if (this.disabled) {
            return false;
        }
        if (this.aberto) {
            this.fechar();
        }
        else {
            this.aberto = true;
            if (!this.data) {
                this.data = [];
            }
            if (!this._value) {
                this._value = [];
            }
            this.valorPesquisado = '';
            this.campoBusca.nativeElement.focus();
            this.setFocus(true);
            this.onAbrir.emit(true);
            this.buscar();
        }
    };
    /**
     * @param {?} item
     * @return {?}
     */
    MultipleComponent.prototype.selecionar = function (item) {
        var _this = this;
        //verifica se ja foi adicionado
        var /** @type {?} */ jaExiste = this.data.findIndex(function (procurar) { return procurar[_this.indiceId] == item[_this.indiceId]; });
        if (jaExiste === -1) {
            this.data.push(item);
        }
        this.updateValue(this.data);
        this.onSelecionarItem.emit(item);
        this.fechar();
        //apaga campo de busca
        this.campoBusca.nativeElement.value = '';
    };
    /**
     * @return {?}
     */
    MultipleComponent.prototype.getSomenteId = function () {
        var /** @type {?} */ ids = [];
        try {
            for (var _a = tslib_1.__values(this.data), _b = _a.next(); !_b.done; _b = _a.next()) {
                var item = _b.value;
                ids.push(item[this.indiceId]);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return ids;
        var e_1, _c;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    MultipleComponent.prototype.limpar = function (event) {
        event.stopPropagation();
        this.data = null;
        this.updateValue(null);
        this.onLimpar.emit(true);
        this.aberto = false;
        this.abrir();
    };
    /**
     * @param {?} item
     * @param {?} event
     * @return {?}
     */
    MultipleComponent.prototype.remove = function (item, event) {
        _super.prototype.remove.call(this, item, event);
        this.updateValue(this.data);
    };
    /**
     * @return {?}
     */
    MultipleComponent.prototype.buscar = function () {
        var _this = this;
        if (this.validaCaracteresMinimo() == false) {
            return false;
        }
        this.onBuscar.emit(this.valorPesquisado);
        this.valoresExibir = this._valores.filter(function (item) {
            var /** @type {?} */ pesquisa = item[_this.indiceNome].toString().toLocaleLowerCase().indexOf(_this.valorPesquisado.toString().toLocaleLowerCase());
            //verifica se o item da lista original ja n esta add na lista data
            var /** @type {?} */ jaFoiAdicionado = _this.data.findIndex(function (procurar) { return procurar[_this.indiceId] == item[_this.indiceId]; });
            if (pesquisa !== -1 && jaFoiAdicionado === -1) {
                return item;
            }
        });
    };
    Object.defineProperty(MultipleComponent.prototype, "value", {
        /**
         * @return {?}
         */
        get: function () { return this._value; },
        /**
         * @param {?} v
         * @return {?}
         */
        set: function (v) {
            if (v !== this._value) {
                this._value = (v);
                this._onChangeCallback(v);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    /**
     * @param {?} value
     * @return {?}
     */
    MultipleComponent.prototype.writeValue = function (value) {
        this.data = value;
        this._value = value;
    };
    /**
     * @param {?} value
     * @return {?}
     */
    MultipleComponent.prototype.updateValue = function (value) {
        var _this = this;
        this.zone.run(function () {
            _this._value = value;
            _this.onChange(value);
            _this._onTouchedCallback();
            _this.change.emit(value);
        });
    };
    /**
     * @param {?} _
     * @return {?}
     */
    MultipleComponent.prototype.onChange = function (_) { };
    /**
     * @return {?}
     */
    MultipleComponent.prototype.onTouched = function () { };
    /**
     * @param {?} fn
     * @return {?}
     */
    MultipleComponent.prototype.registerOnChange = function (fn) { this.onChange = fn; };
    /**
     * @param {?} fn
     * @return {?}
     */
    MultipleComponent.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
    /**
     * @param {?} _
     * @return {?}
     */
    MultipleComponent.prototype._onChangeCallback = function (_) { };
    /**
     * @return {?}
     */
    MultipleComponent.prototype._onTouchedCallback = function () { };
    return MultipleComponent;
}(Select));
export { MultipleComponent };
MultipleComponent.decorators = [
    { type: Component, args: [{
                selector: 'select2-multiple',
                template: "\n        <!--select simples-->\n        <span [ngClass]=\"getClassGeral()\" dir=\"ltr\" (click)=\"abrir()\">\n        <span class=\"selection\">\n            <span class=\"select2-selection select2-selection--multiple\" role=\"combobox\" aria-haspopup=\"true\" aria-expanded=\"false\" tabindex=\"-1\">\n            <ul class=\"select2-selection__rendered\">\n                <li [hidden]=\"data\" [innerHtml]=\"placeholder\"  class=\"select2-selection__placeholder\"></li>\n                <span [hidden]=\"!data\" >\n                    <span [inner-template]=\"templateSelecionado || templateSelecionadoInterno\" [item]=\"this\"></span>\n                </span>\n                <li class=\"select2-selection__arrow\" role=\"presentation\"><b role=\"presentation\"></b></li>\n            </ul>\n        </span>\n        </span>\n        <span class=\"dropdown-wrapper\" aria-hidden=\"true\"></span>\n    </span>\n\n        <!--quando clicar campo-->\n        <div [hidden]=\"!aberto\">\n        <span class=\"select2-container select2-container--bootstrap select2-container--open\">\n            <span class=\"select2-dropdown select2-dropdown--below\" dir=\"ltr\" >\n                <span class=\"select2-search select2-search--dropdown\">\n                    <input (keyup)=\"keyup($event.target.value)\" #campoBusca placeholder=\"Digite algo\" autofocus class=\"select2-search__field\" type=\"search\" tabindex=\"0\" autocomplete=\"off\" autocorrect=\"off\" autocapitalize=\"off\" spellcheck=\"false\" role=\"textbox\">\n                </span>\n                <span class=\"select2-results\">\n                    <ul class=\"select2-results__options\" role=\"tree\"  aria-expanded=\"true\" aria-hidden=\"false\">\n                        <span [hidden]=\"exibirMensagemCaracteresMinimo\">\n                            <span [hidden]=\"valoresExibir.length == 0\" >\n                                <li *ngFor=\"let item of valoresExibir\" (click)=\"selecionar(item)\" class=\"select2-results__option\" highlight=\"select2-results__option--highlighted\" role=\"treeitem\" [attr.aria-selected]=\"((_value) && (item[indiceId] == _value[indiceId])) ? true : false\">\n                                    <span  [inner-template]=\"templateResultado || templateResultadoInterno\" [item]=\"item\"></span>\n                                </li>\n                            </span>\n                            <li [hidden]=\"valoresExibir.length > 0\" class=\"select2-results__option select2-results__message\" aria-live=\"assertive\">\n                                <span  [inner-template]=\"templateSemResultado || templateSemResultadoInterno\" [item]=\"{pesquisa:valorPesquisado}\"></span>\n                            </li>\n                        </span>\n                        <li [hidden]=\"exibirMensagemCaracteresMinimo == false\" class=\"select2-results__option select2-results__message\">\n                            Digite {{minimoCaracteres}} ou mais caracteres para realizar a busca\n                        </li>\n                    </ul>\n                </span>\n            </span>\n        </span>\n        </div>\n\n\n\n        <ng-template #templateSemResultadoInterno>\n            Nenhum resultado encontrado\n        </ng-template>\n        <ng-template #templateResultadoInterno let-valor>\n            {{valor[indiceNome]}}\n        </ng-template>\n        <ng-template #templateSelecionadoInterno let-valor>\n        <span *ngIf=\"valor\">\n            <li *ngFor=\"let item of valor.data\" class=\"select2-selection__choice\">\n                <span class=\"select2-selection__choice__remove\" role=\"presentation\" (click)=\"valor.remove(item, $event)\">\u00D7</span>\n                {{item[indiceNome]}}\n            </li>\n        </span>\n        </ng-template>\n    ",
                providers: [
                    {
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: forwardRef(function () { return MultipleComponent; }),
                        multi: true
                    }
                ],
                host: {
                    '(document:click)': 'clickForaComponent($event)',
                    '(focus)': 'setFocus(true)',
                    '(blur)': 'setFocus(false)',
                },
            },] },
];
/** @nocollapse */
MultipleComponent.ctorParameters = function () { return [
    { type: ElementRef, },
    { type: NgZone, },
]; };
MultipleComponent.propDecorators = {
    "name": [{ type: Input },],
    "classe": [{ type: Input },],
    "placeholder": [{ type: Input },],
    "minimoCaracteres": [{ type: Input },],
    "templateResultado": [{ type: Input },],
    "templateSelecionado": [{ type: Input },],
    "templateSemResultado": [{ type: Input },],
    "disabled": [{ type: Input },],
    "indiceId": [{ type: Input },],
    "indiceNome": [{ type: Input },],
    "valores": [{ type: Input },],
    "change": [{ type: Output },],
    "onSelecionarItem": [{ type: Output },],
    "onBuscar": [{ type: Output },],
    "onApagar": [{ type: Output },],
    "onRemoverItem": [{ type: Output },],
    "onAbrir": [{ type: Output },],
    "onFechar": [{ type: Output },],
    "onLimpar": [{ type: Output },],
    "campoBusca": [{ type: ViewChild, args: ['campoBusca',] },],
    "value": [{ type: Input },],
};
function MultipleComponent_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    MultipleComponent.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    MultipleComponent.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    MultipleComponent.propDecorators;
    /** @type {?} */
    MultipleComponent.prototype.name;
    /** @type {?} */
    MultipleComponent.prototype.classe;
    /** @type {?} */
    MultipleComponent.prototype.placeholder;
    /** @type {?} */
    MultipleComponent.prototype.minimoCaracteres;
    /** @type {?} */
    MultipleComponent.prototype.templateResultado;
    /** @type {?} */
    MultipleComponent.prototype.templateSelecionado;
    /** @type {?} */
    MultipleComponent.prototype.templateSemResultado;
    /** @type {?} */
    MultipleComponent.prototype.disabled;
    /** @type {?} */
    MultipleComponent.prototype.indiceId;
    /** @type {?} */
    MultipleComponent.prototype.indiceNome;
    /** @type {?} */
    MultipleComponent.prototype.change;
    /** @type {?} */
    MultipleComponent.prototype.onSelecionarItem;
    /** @type {?} */
    MultipleComponent.prototype.onBuscar;
    /** @type {?} */
    MultipleComponent.prototype.onApagar;
    /** @type {?} */
    MultipleComponent.prototype.onRemoverItem;
    /** @type {?} */
    MultipleComponent.prototype.onAbrir;
    /** @type {?} */
    MultipleComponent.prototype.onFechar;
    /** @type {?} */
    MultipleComponent.prototype.onLimpar;
    /** @type {?} */
    MultipleComponent.prototype.campoBusca;
    /** @type {?} */
    MultipleComponent.prototype.elementRef;
    /** @type {?} */
    MultipleComponent.prototype.zone;
}
//# sourceMappingURL=multiple.component.js.map
