import * as tslib_1 from "tslib";
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Component, Input, ElementRef, forwardRef, NgZone, Output, EventEmitter, ViewChild, Renderer } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { Select } from './../common/select';
import { SelectService } from '../service/select.service';
var RequestMultipleComponent = /** @class */ (function (_super) {
    tslib_1.__extends(RequestMultipleComponent, _super);
    /**
     * @param {?} elementRef
     * @param {?} zone
     * @param {?} requisicao
     * @param {?} renderer
     */
    function RequestMultipleComponent(elementRef, zone, requisicao, renderer) {
        var _this = _super.call(this, elementRef, zone) || this;
        _this.elementRef = elementRef;
        _this.zone = zone;
        _this.requisicao = requisicao;
        _this.renderer = renderer;
        _this.name = '';
        _this.classe = '';
        _this.placeholder = 'Selecione';
        _this.minimoCaracteres = 0;
        _this.disabled = false;
        _this.indiceId = 'id';
        _this.indiceNome = 'nome';
        _this.change = new EventEmitter();
        _this.onSelecionarItem = new EventEmitter();
        _this.onBuscar = new EventEmitter();
        _this.onApagar = new EventEmitter();
        _this.onRemoverItem = new EventEmitter();
        _this.onAbrir = new EventEmitter();
        _this.onFechar = new EventEmitter();
        _this.onLimpar = new EventEmitter();
        _this.onErro = new EventEmitter();
        _this.onProcessaResultado = new EventEmitter();
        _this.onProcessaParametros = new EventEmitter();
        _this.pagina = 1;
        _this.quantidadePadrao = 0;
        _this.buscando = false;
        _this.semResultado = false;
        return _this;
    }
    /**
     * @return {?}
     */
    RequestMultipleComponent.prototype.ngOnDestroy = function () {
        if (this.subscrebeBusca) {
            this.subscrebeBusca.unsubscribe();
        }
    };
    /**
     * @return {?}
     */
    RequestMultipleComponent.prototype.abrir = function () {
        if (this.disabled) {
            return false;
        }
        if (this.aberto) {
            this.fechar();
        }
        else {
            this.aberto = true;
            if (!this.data) {
                this.data = [];
            }
            this.onAbrir.emit(true);
            // this.renderer.invokeElementMethod(this.campoBusca.nativeElement, 'focus', []);
            this.pagina = 1;
            this.semResultado = false;
            this.quantidadePadrao = 0;
            this.valorPesquisado = '';
            this.campoBusca.nativeElement.value = '';
            this.setFocus(true);
            this.buscar();
        }
    };
    /**
     * @param {?} valor
     * @return {?}
     */
    RequestMultipleComponent.prototype.keyup = function (valor) {
        if (this.valorPesquisado == valor) {
            return null;
        }
        this.valoresExibir = [];
        this.valorPesquisado = valor;
        this.pagina = 1;
        this.buscar();
    };
    /**
     * @param {?} item
     * @return {?}
     */
    RequestMultipleComponent.prototype.selecionar = function (item) {
        var _this = this;
        var /** @type {?} */ jaExiste = this.data.findIndex(function (procurar) { return procurar[_this.indiceId] == item[_this.indiceId]; });
        if (jaExiste === -1) {
            this.data.push(item);
        }
        this.updateValue(this.data);
        this.onSelecionarItem.emit(item);
        this.fechar();
        //apaga campo de busca
        this.campoBusca.nativeElement.value = '';
    };
    /**
     * @return {?}
     */
    RequestMultipleComponent.prototype.getSomenteId = function () {
        var /** @type {?} */ ids = [];
        try {
            for (var _a = tslib_1.__values(this.data), _b = _a.next(); !_b.done; _b = _a.next()) {
                var item = _b.value;
                ids.push(item[this.indiceId]);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return ids;
        var e_1, _c;
    };
    /**
     * @return {?}
     */
    RequestMultipleComponent.prototype.limpar = function () {
        this.data = [];
        this.updateValue(null);
        this.aberto = false;
        this.onLimpar.emit(true);
        this.abrir();
    };
    /**
     * @return {?}
     */
    RequestMultipleComponent.prototype.buscar = function () {
        var _this = this;
        if (this.validaCaracteresMinimo() == false) {
            return false;
        }
        this.buscando = true;
        // this.valoresExibir = this._valores.filter(item => item[this.indiceNome].indexOf(this.valorPesquisado) !== -1);
        var /** @type {?} */ parametros = {
            enviado: {
                pagina: this.pagina,
                valorPesquisado: this.valorPesquisado,
                idSelecionados: this.getSomenteId(),
            },
            retorno: {}
        };
        //mata o subscribe
        this.ngOnDestroy();
        this.onBuscar.emit(this.valorPesquisado);
        this.onProcessaParametros.emit(parametros);
        this.subscrebeBusca = this.requisicao.getResultados(this.url, parametros.retorno).subscribe(function (resultado) {
            var /** @type {?} */ objEmit = { enviado: resultado, retorno: [] };
            _this.onProcessaResultado.emit(objEmit);
            var /** @type {?} */ exibirResultado = objEmit.retorno;
            if (Array.isArray(exibirResultado)) {
                if (_this.quantidadePadrao == 0 && exibirResultado.length < 25) {
                    _this.semResultado = true;
                }
                if (_this.quantidadePadrao == 0) {
                    _this.quantidadePadrao = exibirResultado.length;
                }
                if (_this.quantidadePadrao != exibirResultado.length) {
                    _this.semResultado = true;
                }
                _this.valoresExibir = _this.valoresExibir.concat(exibirResultado);
            }
            else {
                console.log('Ng2Select2Bootstrap: retorno não é um select', exibirResultado);
            }
            _this.buscando = false;
        }, function (erro) {
            if (erro.status == 409) {
                _this.semResultado = true;
            }
            _this.onErro.emit(erro);
            _this.buscando = false;
        });
    };
    /**
     * @return {?}
     */
    RequestMultipleComponent.prototype.onScroll = function () {
        if (!this.buscando && !this.semResultado) {
            this.pagina++;
            this.buscar();
        }
    };
    Object.defineProperty(RequestMultipleComponent.prototype, "value", {
        /**
         * @return {?}
         */
        get: function () { return this._value; },
        /**
         * @param {?} v
         * @return {?}
         */
        set: function (v) {
            if (v !== this._value) {
                this._value = v;
                this._onChangeCallback(v);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    return RequestMultipleComponent;
}(Select));
export { RequestMultipleComponent };
RequestMultipleComponent.decorators = [
    { type: Component, args: [{
                selector: 'select2-request-multiple',
                template: "\n        <span [ngClass]=\"getClassGeral()\"  dir=\"ltr\" (click)=\"abrir()\">\n        <span class=\"selection\">\n            <span class=\"select2-selection select2-selection--multiple\" role=\"combobox\" aria-haspopup=\"true\" aria-expanded=\"false\" tabindex=\"-1\">\n            <ul class=\"select2-selection__rendered\">\n                <li [hidden]=\"data\" [innerHtml]=\"placeholder\"  class=\"select2-selection__placeholder\"></li>\n                <span [hidden]=\"!data\" >\n                    <span [inner-template]=\"templateSelecionado || templateSelecionadoInterno\" [item]=\"this\"></span>\n                </span>\n                <li class=\"select2-selection__arrow\" role=\"presentation\"><b role=\"presentation\"></b></li>\n            </ul>\n        </span>\n        </span>\n        <span class=\"dropdown-wrapper\" aria-hidden=\"true\"></span>\n    </span>\n\n        <!--quando clicar campo-->\n        <div [hidden]=\"!aberto\">\n        <span class=\"select2-container select2-container--bootstrap select2-container--open\">\n            <span class=\"select2-dropdown select2-dropdown--below\" style=\"z-index: 999999\" dir=\"ltr\" >\n                <span class=\"select2-search select2-search--dropdown\">\n                    <input (keyup)=\"keyup($event.target.value)\" #campoBusca placeholder=\"Digite algo\" autofocus class=\"select2-search__field\" type=\"search\" tabindex=\"0\" autocomplete=\"off\" autocorrect=\"off\" autocapitalize=\"off\" spellcheck=\"false\" role=\"textbox\">\n                </span>\n                <span class=\"select2-results\" aria-expanded=\"true\" aria-hidden=\"false\">\n                    <ul\n                            class=\"select2-results__options\"\n                            role=\"tree\"\n                            infinite-scroll\n                            scroll-distance=\"0,30\"\n                            (OnScrollMethod)=\"onScroll()\"\n                            style=\" overflow: auto!important;\"\n                    >\n                        <div [style.display]=\"(exibirMensagemCaracteresMinimo) ? 'none': ''\">\n                            <span [style.display]=\"(valoresExibir.length == 0) ? 'none':''\" >\n                                <ng-template [inner-template]=\"templateLista || templateListaInterno\" [item]=\"{component: this}\"></ng-template>\n                            </span>\n                            <li [style.display]=\"(buscando || valoresExibir.length > 0) ? 'none' : ''\" class=\"select2-results__option select2-results__message\" aria-live=\"assertive\">\n                                <span  [inner-template]=\"templateSemResultado || templateSemResultadoInterno\" [item]=\"{pesquisa:valorPesquisado}\"></span>\n                            </li>\n                            <li [style.display]=\"(!buscando) ? 'none' : ''\">\n                                <span [inner-template]=\"templateBuscando || templateBuscandoInterno\"></span>\n                            </li>\n                        </div>\n                        <li [style.display]=\"(exibirMensagemCaracteresMinimo == false) ? 'none': ''\" class=\"select2-results__option select2-results__message\">\n                            Digite {{minimoCaracteres}} ou mais caracteres para realizar a busca\n                        </li>\n                    </ul>\n                </span>\n            </span>\n        </span>\n        </div>\n\n\n\n        <ng-template #templateSemResultadoInterno>\n            Nenhum resultado encontrado\n        </ng-template>\n        <ng-template #templateResultadoInterno let-valor>\n            {{valor[indiceNome]}}\n        </ng-template>\n        <ng-template #templateSelecionadoInterno let-valor>\n       <span *ngIf=\"valor\">\n            <li *ngFor=\"let item of valor.data\" class=\"select2-selection__choice\">\n                <span class=\"select2-selection__choice__remove\" role=\"presentation\" (click)=\"valor.remove(item, $event)\">\u00D7</span>\n                {{item[indiceNome]}}\n            </li>\n        </span>\n        </ng-template>\n        <ng-template #templateBuscandoInterno>\n            <span class=\"fa fa-5x fa-refresh fa-spin\" style=\" width: auto;margin:auto 50% !important\"></span>\n        </ng-template>\n         <ng-template #templateListaInterno let-valor>\n            <li \n                *ngFor=\"let item of valor.component.valoresExibir\" \n                (click)=\"valor.component.selecionar(item)\" class=\"select2-results__option\" \n                highlight=\"select2-results__option--highlighted\" \n                role=\"treeitem\" \n                [attr.aria-selected]=\"((_value) && (item[valor.component.indiceId] == _value[valor.component.indiceId])) ? true : false\"\n                \n            >\n                <div [inner-template]=\"templateResultado || templateResultadoInterno\" [item]=\"item\"></div>\n            </li>\n        </ng-template>\n\n    ",
                providers: [
                    {
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: forwardRef(function () { return RequestMultipleComponent; }),
                        multi: true
                    }
                ],
                host: {
                    '(document:click)': 'clickForaComponent($event)',
                    '(focus)': 'setFocus(true)',
                    '(blur)': 'setFocus(false)',
                },
            },] },
];
/** @nocollapse */
RequestMultipleComponent.ctorParameters = function () { return [
    { type: ElementRef, },
    { type: NgZone, },
    { type: SelectService, },
    { type: Renderer, },
]; };
RequestMultipleComponent.propDecorators = {
    "name": [{ type: Input },],
    "classe": [{ type: Input },],
    "placeholder": [{ type: Input },],
    "minimoCaracteres": [{ type: Input },],
    "templateResultado": [{ type: Input },],
    "templateLista": [{ type: Input },],
    "templateSelecionado": [{ type: Input },],
    "templateSemResultado": [{ type: Input },],
    "templateBuscando": [{ type: Input },],
    "disabled": [{ type: Input },],
    "indiceId": [{ type: Input },],
    "indiceNome": [{ type: Input },],
    "url": [{ type: Input },],
    "change": [{ type: Output },],
    "onSelecionarItem": [{ type: Output },],
    "onBuscar": [{ type: Output },],
    "onApagar": [{ type: Output },],
    "onRemoverItem": [{ type: Output },],
    "onAbrir": [{ type: Output },],
    "onFechar": [{ type: Output },],
    "onLimpar": [{ type: Output },],
    "onErro": [{ type: Output },],
    "onProcessaResultado": [{ type: Output },],
    "onProcessaParametros": [{ type: Output },],
    "campoBusca": [{ type: ViewChild, args: ['campoBusca',] },],
    "value": [{ type: Input },],
};
function RequestMultipleComponent_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    RequestMultipleComponent.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    RequestMultipleComponent.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    RequestMultipleComponent.propDecorators;
    /** @type {?} */
    RequestMultipleComponent.prototype.name;
    /** @type {?} */
    RequestMultipleComponent.prototype.classe;
    /** @type {?} */
    RequestMultipleComponent.prototype.placeholder;
    /** @type {?} */
    RequestMultipleComponent.prototype.minimoCaracteres;
    /** @type {?} */
    RequestMultipleComponent.prototype.templateResultado;
    /** @type {?} */
    RequestMultipleComponent.prototype.templateLista;
    /** @type {?} */
    RequestMultipleComponent.prototype.templateSelecionado;
    /** @type {?} */
    RequestMultipleComponent.prototype.templateSemResultado;
    /** @type {?} */
    RequestMultipleComponent.prototype.templateBuscando;
    /** @type {?} */
    RequestMultipleComponent.prototype.disabled;
    /** @type {?} */
    RequestMultipleComponent.prototype.indiceId;
    /** @type {?} */
    RequestMultipleComponent.prototype.indiceNome;
    /** @type {?} */
    RequestMultipleComponent.prototype.url;
    /** @type {?} */
    RequestMultipleComponent.prototype.change;
    /** @type {?} */
    RequestMultipleComponent.prototype.onSelecionarItem;
    /** @type {?} */
    RequestMultipleComponent.prototype.onBuscar;
    /** @type {?} */
    RequestMultipleComponent.prototype.onApagar;
    /** @type {?} */
    RequestMultipleComponent.prototype.onRemoverItem;
    /** @type {?} */
    RequestMultipleComponent.prototype.onAbrir;
    /** @type {?} */
    RequestMultipleComponent.prototype.onFechar;
    /** @type {?} */
    RequestMultipleComponent.prototype.onLimpar;
    /** @type {?} */
    RequestMultipleComponent.prototype.onErro;
    /** @type {?} */
    RequestMultipleComponent.prototype.onProcessaResultado;
    /** @type {?} */
    RequestMultipleComponent.prototype.onProcessaParametros;
    /** @type {?} */
    RequestMultipleComponent.prototype.campoBusca;
    /** @type {?} */
    RequestMultipleComponent.prototype.pagina;
    /** @type {?} */
    RequestMultipleComponent.prototype.quantidadePadrao;
    /** @type {?} */
    RequestMultipleComponent.prototype.buscando;
    /** @type {?} */
    RequestMultipleComponent.prototype.semResultado;
    /** @type {?} */
    RequestMultipleComponent.prototype.subscrebeBusca;
    /** @type {?} */
    RequestMultipleComponent.prototype.elementRef;
    /** @type {?} */
    RequestMultipleComponent.prototype.zone;
    /** @type {?} */
    RequestMultipleComponent.prototype.requisicao;
    /** @type {?} */
    RequestMultipleComponent.prototype.renderer;
}
//# sourceMappingURL=request-multiple.component.js.map
