import * as tslib_1 from "tslib";
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Component, Input, ElementRef, forwardRef, NgZone, Output, EventEmitter, ViewChild, Renderer } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { Select } from './../common/select';
import { SelectService } from '../service/select.service';
var RequestComponent = /** @class */ (function (_super) {
    tslib_1.__extends(RequestComponent, _super);
    /**
     * @param {?} elementRef
     * @param {?} zone
     * @param {?} requisicao
     * @param {?} renderer
     */
    function RequestComponent(elementRef, zone, requisicao, renderer) {
        var _this = _super.call(this, elementRef, zone) || this;
        _this.elementRef = elementRef;
        _this.zone = zone;
        _this.requisicao = requisicao;
        _this.renderer = renderer;
        _this.name = '';
        _this.classe = '';
        _this.minimoCaracteres = 0;
        _this.placeholder = 'Selecione';
        _this.disabled = false;
        _this.indiceId = 'id';
        _this.indiceNome = 'nome';
        _this.change = new EventEmitter();
        _this.onSelecionarItem = new EventEmitter();
        _this.onBuscar = new EventEmitter();
        _this.onApagar = new EventEmitter();
        _this.onRemoverItem = new EventEmitter();
        _this.onAbrir = new EventEmitter();
        _this.onFechar = new EventEmitter();
        _this.onLimpar = new EventEmitter();
        _this.onErro = new EventEmitter();
        _this.onProcessaResultado = new EventEmitter();
        _this.onProcessaParametros = new EventEmitter();
        _this.pagina = 1;
        _this.quantidadePadrao = 0;
        _this.buscando = false;
        _this.semResultado = false;
        return _this;
    }
    /**
     * @return {?}
     */
    RequestComponent.prototype.ngOnDestroy = function () {
        if (this.subscrebeBusca) {
            this.subscrebeBusca.unsubscribe();
        }
    };
    /**
     * @return {?}
     */
    RequestComponent.prototype.abrir = function () {
        if (this.disabled) {
            return false;
        }
        if (this.aberto) {
            this.fechar();
        }
        else {
            this.setFocus(true);
            this.aberto = true;
            // this.renderer.invokeElementMethod(this.campoBusca.nativeElement, 'focus', []);
            this.pagina = 1;
            this.semResultado = false;
            this.quantidadePadrao = 0;
            this.valorPesquisado = '';
            this.campoBusca.nativeElement.value = '';
            this.setFocus(true);
            this.onAbrir.emit(true);
            this.buscar();
        }
    };
    /**
     * @param {?} valor
     * @return {?}
     */
    RequestComponent.prototype.keyup = function (valor) {
        if (this.valorPesquisado == valor) {
            return null;
        }
        this.valoresExibir = [];
        this.valorPesquisado = valor;
        this.pagina = 1;
        this.buscar();
    };
    /**
     * @param {?} item
     * @return {?}
     */
    RequestComponent.prototype.selecionar = function (item) {
        this.data = item;
        _super.prototype.selecionar.call(this, item);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    RequestComponent.prototype.limpar = function (event) {
        event.stopPropagation();
        this.data = null;
        this.updateValue(null);
        this.onLimpar.emit(true);
        if (this.aberto) {
            this.fechar();
        }
        else {
            this.abrir();
        }
    };
    /**
     * @return {?}
     */
    RequestComponent.prototype.buscar = function () {
        var _this = this;
        if (this.validaCaracteresMinimo() == false) {
            return false;
        }
        this.buscando = true;
        // this.valoresExibir = this._valores.filter(item => item[this.indiceNome].indexOf(this.valorPesquisado) !== -1);
        var /** @type {?} */ parametros = {
            enviado: {
                pagina: this.pagina,
                valorPesquisado: this.valorPesquisado,
            },
            retorno: {}
        };
        //mata o subscribe
        this.ngOnDestroy();
        this.onBuscar.emit(this.valorPesquisado);
        this.onProcessaParametros.emit(parametros);
        this.subscrebeBusca = this.requisicao.getResultados(this.url, parametros.retorno).subscribe(function (resultado) {
            var /** @type {?} */ objEmit = { enviado: resultado, retorno: [] };
            _this.onProcessaResultado.emit(objEmit);
            var /** @type {?} */ exibirResultado = objEmit.retorno;
            if (Array.isArray(exibirResultado)) {
                if (_this.quantidadePadrao == 0) {
                    _this.quantidadePadrao = exibirResultado.length;
                }
                if (_this.quantidadePadrao != exibirResultado.length) {
                    _this.semResultado = true;
                }
                _this.valoresExibir = _this.valoresExibir.concat(exibirResultado);
            }
            else {
                console.log('Ng2Select2Bootstrap: retorno não é um select', exibirResultado);
            }
            _this.buscando = false;
        }, function (erro) {
            console.log(erro);
            if (erro.status == 409) {
                _this.semResultado = true;
            }
            _this.onErro.emit(erro);
            _this.buscando = false;
        });
    };
    /**
     * @return {?}
     */
    RequestComponent.prototype.onScroll = function () {
        if (!this.buscando && !this.semResultado) {
            this.pagina++;
            this.buscar();
        }
    };
    Object.defineProperty(RequestComponent.prototype, "value", {
        /**
         * @return {?}
         */
        get: function () { return this._value; },
        /**
         * @param {?} v
         * @return {?}
         */
        set: function (v) {
            if (v !== this._value) {
                this._value = v;
                this._onChangeCallback(v);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    return RequestComponent;
}(Select));
export { RequestComponent };
RequestComponent.decorators = [
    { type: Component, args: [{
                selector: 'select2-request',
                template: "\n\n<!--select simples-->\n<span [ngClass]=\"getClassGeral()\" [tabindex]=\"tabIndex\" dir=\"ltr\" (focus)=\"abrir()\" (click)=\"abrir()\">\n        <span class=\"selection\">\n            <!--simples-->\n            <span class=\"select2-selection select2-selection--single\" role=\"combobox\" aria-haspopup=\"true\" aria-expanded=\"false\" tabindex=\"0\" [ngStyle]=\"styleItemSelecionado\">\n                <span class=\"select2-selection__rendered\">\n                    <span [hidden]=\"!data\" (click)=\"limpar($event)\" class=\"select2-selection__clear\">\u00D7</span>\n                    <span [hidden]=\"!data\" [inner-template]=\"templateSelecionado || templateSelecionadoInterno\" [item]=\"data\"></span>\n                    <span [hidden]=\"data\" [innerHtml]=\"placeholder\" class=\"select2-selection__placeholder\"></span>\n\n                </span>\n                <span class=\"select2-selection__arrow\" role=\"presentation\">\n                    <b role=\"presentation\"></b>\n                </span>\n            </span>\n        </span>\n        <span class=\"dropdown-wrapper\" aria-hidden=\"true\"></span>\n    </span>\n\n<!--quando clicar campo-->\n<div [hidden]=\"!aberto\">\n    <div class=\"select2-container select2-container--bootstrap select2-container--open\">\n        <div class=\"select2-dropdown select2-dropdown--below\" style=\"z-index: 999999\" dir=\"ltr\" >\n            <div class=\"select2-search select2-search--dropdown\">\n                <input (keyup)=\"keyup($event.target.value)\" #campoBusca placeholder=\"Digite algo\" autofocus class=\"select2-search__field\" type=\"search\" tabindex=\"0\" autocomplete=\"off\" autocorrect=\"off\" autocapitalize=\"off\" spellcheck=\"false\" role=\"textbox\">\n            </div>\n            <span class=\"select2-results\" aria-expanded=\"true\" aria-hidden=\"false\">\n                        <ul\n                                class=\"select2-results__options\"\n                                role=\"tree\"\n                                infinite-scroll\n                                scroll-distance=\"0,30\"\n                                (OnScrollMethod)=\"onScroll()\"\n                                style=\" overflow: auto!important;\"\n                        >\n                            <div [style.display]=\"(exibirMensagemCaracteresMinimo) ? 'none': ''\">\n                                <div [style.display]=\"(valoresExibir.length == 0) ? 'none':''\" >\n                                    <!--<ng-template -->\n                                    <!--*ngIf=\"templateLista\"-->\n                                    <!--[inner-template]=\"templateLista\" -->\n                                    <!--[item]=\"{valoresExibir: valoresExibir, component: this}\"-->\n                                    <!--&gt;-->\n                                    <!--</ng-template>-->\n                                    <!--<ng-template *ngIf=\"!templateLista\">-->\n\n                                    <!--</ng-template>-->\n                                    <ng-template [inner-template]=\"templateLista || templateListaInterno\" [item]=\"{component: this}\">\n\n                                    </ng-template>\n\n                                </div>\n\n                                <li [style.display]=\"(buscando || valoresExibir.length > 0) ? 'none' : ''\" class=\"select2-results__option select2-results__message\" aria-live=\"assertive\">\n                                    <ng-template  [inner-template]=\"templateSemResultado || templateSemResultadoInterno\" [item]=\"{pesquisa:valorPesquisado}\"></ng-template>\n                                </li>\n                                <li [style.display]=\"(!buscando) ? 'none' : ''\">\n                                    <ng-template [inner-template]=\"templateBuscando || templateBuscandoInterno\"></ng-template>\n                                </li>\n                            </div>\n                            <li [style.display]=\"(exibirMensagemCaracteresMinimo == false) ? 'none': ''\" class=\"select2-results__option select2-results__message\">\n                                Digite {{minimoCaracteres}} ou mais caracteres para realizar a busca\n                            </li>\n                        </ul>\n                    </span>\n        </div>\n    </div>\n</div>\n\n\n\n<ng-template #templateSemResultadoInterno>\n    Nenhum resultado encontrado\n</ng-template>\n<ng-template #templateResultadoInterno let-valor>\n    {{valor[indiceNome]}}\n</ng-template>\n<ng-template #templateSelecionadoInterno let-valor>\n        <span *ngIf=\"valor\"  [ngStyle]=\"styleItemSelecionado\">\n            {{valor[indiceNome]}}\n        </span>\n</ng-template>\n<ng-template #templateBuscandoInterno>\n    <span class=\"fa fa-5x fa-refresh fa-spin\" style=\" width: auto;margin:auto 50% !important\"></span>\n</ng-template>\n<ng-template #templateListaInterno let-valor>\n    <li\n            *ngFor=\"let item of valor.component.valoresExibir\"\n            (click)=\"valor.component.selecionar(item)\" class=\"select2-results__option\"\n            highlight=\"select2-results__option--highlighted\"\n            role=\"treeitem\"\n            [attr.aria-selected]=\"((_value) && (item[valor.component.indiceId] == _value[valor.component.indiceId])) ? true : false\"\n\n    >\n        <div [inner-template]=\"templateResultado || templateResultadoInterno\" [item]=\"item\"></div>\n    </li>\n</ng-template>",
                providers: [
                    {
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: forwardRef(function () { return RequestComponent; }),
                        multi: true
                    }
                ],
                host: {
                    '(document:click)': 'clickForaComponent($event)',
                    '(focus)': 'abrir()',
                    '(blur)': 'fechar()',
                },
            },] },
];
/** @nocollapse */
RequestComponent.ctorParameters = function () { return [
    { type: ElementRef, },
    { type: NgZone, },
    { type: SelectService, },
    { type: Renderer, },
]; };
RequestComponent.propDecorators = {
    "name": [{ type: Input },],
    "classe": [{ type: Input },],
    "tabIndex": [{ type: Input },],
    "styleItemSelecionado": [{ type: Input },],
    "minimoCaracteres": [{ type: Input },],
    "placeholder": [{ type: Input },],
    "templateResultado": [{ type: Input },],
    "templateLista": [{ type: Input },],
    "templateSelecionado": [{ type: Input },],
    "templateSemResultado": [{ type: Input },],
    "templateBuscando": [{ type: Input },],
    "disabled": [{ type: Input },],
    "indiceId": [{ type: Input },],
    "indiceNome": [{ type: Input },],
    "url": [{ type: Input },],
    "change": [{ type: Output },],
    "onSelecionarItem": [{ type: Output },],
    "onBuscar": [{ type: Output },],
    "onApagar": [{ type: Output },],
    "onRemoverItem": [{ type: Output },],
    "onAbrir": [{ type: Output },],
    "onFechar": [{ type: Output },],
    "onLimpar": [{ type: Output },],
    "onErro": [{ type: Output },],
    "onProcessaResultado": [{ type: Output },],
    "onProcessaParametros": [{ type: Output },],
    "campoBusca": [{ type: ViewChild, args: ['campoBusca',] },],
    "value": [{ type: Input },],
};
function RequestComponent_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    RequestComponent.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    RequestComponent.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    RequestComponent.propDecorators;
    /** @type {?} */
    RequestComponent.prototype.name;
    /** @type {?} */
    RequestComponent.prototype.classe;
    /** @type {?} */
    RequestComponent.prototype.tabIndex;
    /** @type {?} */
    RequestComponent.prototype.styleItemSelecionado;
    /** @type {?} */
    RequestComponent.prototype.minimoCaracteres;
    /** @type {?} */
    RequestComponent.prototype.placeholder;
    /** @type {?} */
    RequestComponent.prototype.templateResultado;
    /** @type {?} */
    RequestComponent.prototype.templateLista;
    /** @type {?} */
    RequestComponent.prototype.templateSelecionado;
    /** @type {?} */
    RequestComponent.prototype.templateSemResultado;
    /** @type {?} */
    RequestComponent.prototype.templateBuscando;
    /** @type {?} */
    RequestComponent.prototype.disabled;
    /** @type {?} */
    RequestComponent.prototype.indiceId;
    /** @type {?} */
    RequestComponent.prototype.indiceNome;
    /** @type {?} */
    RequestComponent.prototype.url;
    /** @type {?} */
    RequestComponent.prototype.change;
    /** @type {?} */
    RequestComponent.prototype.onSelecionarItem;
    /** @type {?} */
    RequestComponent.prototype.onBuscar;
    /** @type {?} */
    RequestComponent.prototype.onApagar;
    /** @type {?} */
    RequestComponent.prototype.onRemoverItem;
    /** @type {?} */
    RequestComponent.prototype.onAbrir;
    /** @type {?} */
    RequestComponent.prototype.onFechar;
    /** @type {?} */
    RequestComponent.prototype.onLimpar;
    /** @type {?} */
    RequestComponent.prototype.onErro;
    /** @type {?} */
    RequestComponent.prototype.onProcessaResultado;
    /** @type {?} */
    RequestComponent.prototype.onProcessaParametros;
    /** @type {?} */
    RequestComponent.prototype.campoBusca;
    /** @type {?} */
    RequestComponent.prototype.pagina;
    /** @type {?} */
    RequestComponent.prototype.quantidadePadrao;
    /** @type {?} */
    RequestComponent.prototype.buscando;
    /** @type {?} */
    RequestComponent.prototype.semResultado;
    /** @type {?} */
    RequestComponent.prototype.subscrebeBusca;
    /** @type {?} */
    RequestComponent.prototype.elementRef;
    /** @type {?} */
    RequestComponent.prototype.zone;
    /** @type {?} */
    RequestComponent.prototype.requisicao;
    /** @type {?} */
    RequestComponent.prototype.renderer;
}
//# sourceMappingURL=request.component.js.map
