import * as tslib_1 from "tslib";
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Component, Input, ElementRef, forwardRef, NgZone, Output, EventEmitter, ViewChild } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { Select } from './../common/select';
var SelectComponent = /** @class */ (function (_super) {
    tslib_1.__extends(SelectComponent, _super);
    /**
     * @param {?} elementRef
     * @param {?} zone
     */
    function SelectComponent(elementRef, zone) {
        var _this = _super.call(this, elementRef, zone) || this;
        _this.elementRef = elementRef;
        _this.zone = zone;
        _this._valores = [];
        _this.name = '';
        _this.classe = '';
        _this.placeholder = 'Selecione';
        _this.minimoCaracteres = 0;
        _this.indiceId = 'id';
        _this.indiceNome = 'nome';
        _this.disabled = false;
        // @Output() change            = new EventEmitter<any>();
        _this.onSelecionarItem = new EventEmitter();
        _this.onBuscar = new EventEmitter();
        _this.onApagar = new EventEmitter();
        _this.onRemoverItem = new EventEmitter();
        _this.onAbrir = new EventEmitter();
        _this.onFechar = new EventEmitter();
        _this.onLimpar = new EventEmitter();
        return _this;
    }
    Object.defineProperty(SelectComponent.prototype, "valores", {
        /**
         * @param {?} valor
         * @return {?}
         */
        set: function (valor) {
            this._valores = valor;
            this.valoresExibir = valor;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    SelectComponent.prototype.abrir = function () {
        if (this.disabled) {
            return false;
        }
        if (this.aberto) {
            this.fechar();
        }
        else {
            this.aberto = true;
            this.campoBusca.nativeElement.focus();
            this.valorPesquisado = '';
            this.campoBusca.nativeElement.value = '';
            this.setFocus(true);
            this.onAbrir.emit(true);
            this.buscar();
        }
    };
    /**
     * @param {?} item
     * @return {?}
     */
    SelectComponent.prototype.selecionar = function (item) {
        this.data = item;
        _super.prototype.selecionar.call(this, item);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    SelectComponent.prototype.limpar = function (event) {
        event.stopPropagation();
        this.data = null;
        this.updateValue(null);
        this.onLimpar.emit(true);
        if (this.aberto) {
            this.fechar();
        }
        else {
            this.abrir();
        }
    };
    /**
     * @return {?}
     */
    SelectComponent.prototype.buscar = function () {
        var _this = this;
        if (this.validaCaracteresMinimo() == false) {
            return false;
        }
        this.onBuscar.emit(this.valorPesquisado);
        this.valoresExibir = this._valores.filter(function (item) { return item[_this.indiceNome].toString().toLocaleLowerCase().indexOf(_this.valorPesquisado.toString().toLocaleLowerCase()) !== -1; });
    };
    Object.defineProperty(SelectComponent.prototype, "value", {
        /**
         * @return {?}
         */
        get: function () { return this._value; },
        /**
         * @param {?} v
         * @return {?}
         */
        set: function (v) {
            if (v !== this._value) {
                this._value = v;
                this._onChangeCallback(v);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    return SelectComponent;
}(Select));
export { SelectComponent };
SelectComponent.decorators = [
    { type: Component, args: [{
                selector: 'select2-select',
                template: "\n        <!--select simples-->\n        <span [ngClass]=\"getClassGeral()\" dir=\"ltr\" (click)=\"abrir()\">\n        <span class=\"selection\">\n            <!--simples-->\n            <span class=\"select2-selection select2-selection--single\" role=\"combobox\" aria-haspopup=\"true\" aria-expanded=\"false\" tabindex=\"0\">\n                <span class=\"select2-selection__rendered\">\n                    <span [hidden]=\"!data\" (click)=\"limpar($event)\" class=\"select2-selection__clear\">\u00D7</span>\n                    <span [hidden]=\"!data\" class=\"nao-fechar\" [inner-template]=\"templateSelecionado || templateSelecionadoInterno\" [item]=\"data\"></span>\n                    <span [hidden]=\"data\" [innerHtml]=\"placeholder\" class=\"select2-selection__placeholder\"></span>\n\n                </span>\n                <span class=\"select2-selection__arrow\" role=\"presentation\">\n                    <b role=\"presentation\"></b>\n                </span>\n            </span>\n        </span>\n        <span class=\"dropdown-wrapper\" aria-hidden=\"true\"></span>\n    </span>\n\n        <!--quando clicar campo-->\n        <div [hidden]=\"!aberto\">\n        <span class=\"select2-container select2-container--bootstrap select2-container--open\">\n            <span class=\"select2-dropdown select2-dropdown--below\" dir=\"ltr\" >\n                <span class=\"select2-search select2-search--dropdown\">\n                    <input (keyup)=\"keyup($event.target.value)\" #campoBusca placeholder=\"Digite algo\" autofocus class=\"select2-search__field\" type=\"search\" tabindex=\"0\" autocomplete=\"off\" autocorrect=\"off\" autocapitalize=\"off\" spellcheck=\"false\" role=\"textbox\">\n                </span>\n                <span class=\"select2-results\">\n                    <ul class=\"select2-results__options\" role=\"tree\"  aria-expanded=\"true\" aria-hidden=\"false\">\n                        <span [style.display]=\"(exibirMensagemCaracteresMinimo) ? 'none': ''\">\n                            <span [hidden]=\"!valoresExibir.length\" >\n                                <li *ngFor=\"let item of valoresExibir\" (click)=\"selecionar(item)\" class=\"select2-results__option\" highlight=\"select2-results__option--highlighted\" role=\"treeitem\" [attr.aria-selected]=\"((_value) && (item[indiceId] == _value[indiceId])) ? true : false\">\n                                    <span  [inner-template]=\"templateResultado || templateResultadoInterno\" [item]=\"item\"></span>\n                                </li>\n                            </span>\n                            <li [style.display]=\"(valoresExibir.length > 0) ? 'none' : ''\" class=\"select2-results__option select2-results__message\" aria-live=\"assertive\">\n                                <span  [inner-template]=\"templateSemResultado || templateSemResultadoInterno\" [item]=\"{pesquisa:valorPesquisado}\"></span>\n                            </li>\n                        </span>\n                        <li  [style.display]=\"(exibirMensagemCaracteresMinimo == false) ? 'none': ''\" class=\"select2-results__option select2-results__message\">\n                            Digite {{minimoCaracteres}} ou mais caracteres para realizar a busca\n                        </li>\n                    </ul>\n                </span>\n            </span>\n        </span>\n        </div>\n\n\n\n        <ng-template #templateSemResultadoInterno>\n            Nenhum resultado encontrado\n        </ng-template>\n        <ng-template #templateResultadoInterno let-valor>\n            {{valor[indiceNome]}}\n        </ng-template>\n        <ng-template #templateSelecionadoInterno let-valor>\n        <span *ngIf=\"valor\">\n            {{valor[indiceNome]}}\n        </span>\n        </ng-template>\n\n    ",
                providers: [
                    {
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: forwardRef(function () { return SelectComponent; }),
                        multi: true
                    }
                ],
                host: {
                    '(document:click)': 'clickForaComponent($event)',
                    '(focus)': 'setFocus(true)',
                    '(blur)': 'setFocus(false)',
                },
            },] },
];
/** @nocollapse */
SelectComponent.ctorParameters = function () { return [
    { type: ElementRef, },
    { type: NgZone, },
]; };
SelectComponent.propDecorators = {
    "name": [{ type: Input },],
    "classe": [{ type: Input },],
    "placeholder": [{ type: Input },],
    "minimoCaracteres": [{ type: Input },],
    "templateResultado": [{ type: Input },],
    "templateSelecionado": [{ type: Input },],
    "templateSemResultado": [{ type: Input },],
    "indiceId": [{ type: Input },],
    "indiceNome": [{ type: Input },],
    "disabled": [{ type: Input },],
    "valores": [{ type: Input },],
    "onSelecionarItem": [{ type: Output },],
    "onBuscar": [{ type: Output },],
    "onApagar": [{ type: Output },],
    "onRemoverItem": [{ type: Output },],
    "onAbrir": [{ type: Output },],
    "onFechar": [{ type: Output },],
    "onLimpar": [{ type: Output },],
    "campoBusca": [{ type: ViewChild, args: ['campoBusca',] },],
    "value": [{ type: Input },],
};
function SelectComponent_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    SelectComponent.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    SelectComponent.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    SelectComponent.propDecorators;
    /** @type {?} */
    SelectComponent.prototype._valores;
    /** @type {?} */
    SelectComponent.prototype.name;
    /** @type {?} */
    SelectComponent.prototype.classe;
    /** @type {?} */
    SelectComponent.prototype.placeholder;
    /** @type {?} */
    SelectComponent.prototype.minimoCaracteres;
    /** @type {?} */
    SelectComponent.prototype.templateResultado;
    /** @type {?} */
    SelectComponent.prototype.templateSelecionado;
    /** @type {?} */
    SelectComponent.prototype.templateSemResultado;
    /** @type {?} */
    SelectComponent.prototype.indiceId;
    /** @type {?} */
    SelectComponent.prototype.indiceNome;
    /** @type {?} */
    SelectComponent.prototype.disabled;
    /** @type {?} */
    SelectComponent.prototype.onSelecionarItem;
    /** @type {?} */
    SelectComponent.prototype.onBuscar;
    /** @type {?} */
    SelectComponent.prototype.onApagar;
    /** @type {?} */
    SelectComponent.prototype.onRemoverItem;
    /** @type {?} */
    SelectComponent.prototype.onAbrir;
    /** @type {?} */
    SelectComponent.prototype.onFechar;
    /** @type {?} */
    SelectComponent.prototype.onLimpar;
    /** @type {?} */
    SelectComponent.prototype.campoBusca;
    /** @type {?} */
    SelectComponent.prototype.elementRef;
    /** @type {?} */
    SelectComponent.prototype.zone;
}
//# sourceMappingURL=select.component.js.map
