import * as tslib_1 from "tslib";
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Component, Input, ElementRef, forwardRef, NgZone, Output, EventEmitter, ViewChild } from '@angular/core';
import { Select } from './../common/select';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
var TagComponent = /** @class */ (function (_super) {
    tslib_1.__extends(TagComponent, _super);
    /**
     * @param {?} elementRef
     * @param {?} zone
     */
    function TagComponent(elementRef, zone) {
        var _this = _super.call(this, elementRef, zone) || this;
        _this.elementRef = elementRef;
        _this.zone = zone;
        _this.data = [];
        _this._valores = [];
        _this.name = '';
        _this.classe = '';
        _this.placeholder = 'Selecione';
        _this.disabled = false;
        _this.change = new EventEmitter();
        _this.onSelecionarItem = new EventEmitter();
        _this.onBuscar = new EventEmitter();
        _this.onApagar = new EventEmitter();
        _this.onRemoverItem = new EventEmitter();
        _this.onAbrir = new EventEmitter();
        _this.onFechar = new EventEmitter();
        _this.onLimpar = new EventEmitter();
        return _this;
    }
    Object.defineProperty(TagComponent.prototype, "valores", {
        /**
         * @param {?} valor
         * @return {?}
         */
        set: function (valor) {
            this._valores = valor;
            this.valoresExibir = valor;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    TagComponent.prototype.abrir = function () {
        if (this.disabled) {
            return false;
        }
        if (this.aberto) {
            this.fechar();
        }
        else {
            this.aberto = true;
            if (!this._value) {
                this._value = [];
            }
            this.valorPesquisado = '';
            this.campoBusca.nativeElement.focus();
            this.setFocus(true);
            this.onAbrir.emit(true);
            this.buscar();
        }
    };
    /**
     * @param {?} event
     * @return {?}
     */
    TagComponent.prototype.keyup = function (event) {
        event.preventDefault();
        var /** @type {?} */ valor = event.target.value;
        //enter
        if (event.keyCode == 13) {
            this.selecionar(valor, false);
            this.valorPesquisado = '';
            this.buscar();
            return;
        }
        //apagar
        if (event.keyCode == 8) {
            this.remove(this.data[this.data.length - 1], event);
            this.valorPesquisado = '';
            this.buscar();
            event.preventDefault();
            return;
        }
        if (this.valorPesquisado == valor) {
            return null;
        }
        this.valoresExibir = [];
        this.valorPesquisado = valor;
        this.buscar();
    };
    /**
     * @param {?} item
     * @param {?=} fecharCampo
     * @return {?}
     */
    TagComponent.prototype.selecionar = function (item, fecharCampo) {
        if (fecharCampo === void 0) { fecharCampo = true; }
        item = item.trim();
        if (item == '') {
            return false;
        }
        //verifica se ja foi adicionado
        var /** @type {?} */ jaExiste = this.data.findIndex(function (procurar) { return procurar == item; });
        if (jaExiste === -1) {
            this.data.push(item);
        }
        this.updateValue(this.data);
        this.onSelecionarItem.emit(item);
        if (fecharCampo) {
            this.fechar();
        }
        //apaga campo de busca
        this.campoBusca.nativeElement.value = '';
    };
    /**
     * @param {?} event
     * @return {?}
     */
    TagComponent.prototype.limpar = function (event) {
        event.stopPropagation();
        this.data = [];
        this.updateValue(null);
        this.onLimpar.emit(true);
        this.aberto = false;
        this.abrir();
    };
    /**
     * @param {?} item
     * @param {?} event
     * @return {?}
     */
    TagComponent.prototype.remove = function (item, event) {
        event.stopPropagation();
        // this.fechar();
        // let itens
        var /** @type {?} */ posicao = this.data.findIndex(function (procurar) { return procurar == item; });
        if (posicao !== -1) {
            this.data.splice(posicao, 1);
        }
        this.onRemoverItem.emit(item);
        // if(this.data.length == 0){
        //     this.aberto = false;
        //     this.abrir();
        // }
        this.updateValue(this.data);
    };
    /**
     * @return {?}
     */
    TagComponent.prototype.buscar = function () {
        var _this = this;
        if (this.validaCaracteresMinimo() == false) {
            return false;
        }
        this.onBuscar.emit(this.valorPesquisado);
        this.valoresExibir = this._valores.filter(function (item) {
            var /** @type {?} */ pesquisa = item.toString().toLocaleLowerCase().indexOf(_this.valorPesquisado.toString().toLocaleLowerCase());
            //verifica se o item da lista original ja n esta add na lista data
            var /** @type {?} */ jaFoiAdicionado = _this.data.findIndex(function (procurar) { return procurar == item; });
            if (pesquisa !== -1 && jaFoiAdicionado === -1) {
                return item;
            }
        });
    };
    Object.defineProperty(TagComponent.prototype, "value", {
        /**
         * @return {?}
         */
        get: function () { return this._value; },
        /**
         * @param {?} v
         * @return {?}
         */
        set: function (v) {
            if (v !== this._value) {
                this._value = (v);
                this._onChangeCallback(v);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    /**
     * @param {?} value
     * @return {?}
     */
    TagComponent.prototype.writeValue = function (value) {
        if (!Array.isArray(value)) {
            value = [];
        }
        this.data = value;
        this._value = value;
    };
    /**
     * @param {?} value
     * @return {?}
     */
    TagComponent.prototype.updateValue = function (value) {
        var _this = this;
        this.zone.run(function () {
            _this._value = value;
            _this.onChange(value);
            _this._onTouchedCallback();
            _this.change.emit(value);
        });
    };
    /**
     * @param {?} _
     * @return {?}
     */
    TagComponent.prototype.onChange = function (_) { };
    /**
     * @return {?}
     */
    TagComponent.prototype.onTouched = function () { };
    /**
     * @param {?} fn
     * @return {?}
     */
    TagComponent.prototype.registerOnChange = function (fn) { this.onChange = fn; };
    /**
     * @param {?} fn
     * @return {?}
     */
    TagComponent.prototype.registerOnTouched = function (fn) { this.onTouched = fn; };
    /**
     * @param {?} _
     * @return {?}
     */
    TagComponent.prototype._onChangeCallback = function (_) { };
    /**
     * @return {?}
     */
    TagComponent.prototype._onTouchedCallback = function () { };
    return TagComponent;
}(Select));
export { TagComponent };
TagComponent.decorators = [
    { type: Component, args: [{
                selector: 'select2-tag',
                template: "\n        <!--select simples-->\n        <span [ngClass]=\"getClassGeral()\" dir=\"ltr\" (click)=\"abrir()\">\n        <span class=\"selection\">\n            <span class=\"select2-selection select2-selection--multiple\" role=\"combobox\" aria-haspopup=\"true\" aria-expanded=\"false\" tabindex=\"-1\">\n            <ul class=\"select2-selection__rendered\">\n                <span [hidden]=\"data.length == 0\" >\n                    <span [inner-template]=\"templateSelecionado || templateSelecionadoInterno\" [item]=\"this\"></span>\n                </span>\n                <li class=\"select2-search select2-search--inline\" style=\"float:none\">\n                    <input (keyup)=\"keyup($event)\" (keydown.enter)=\"$event.preventDefault()\" #campoBusca class=\"select2-search__field\" type=\"search\" tabindex=\"0\" autocomplete=\"off\" autocorrect=\"off\" autocapitalize=\"off\" spellcheck=\"false\" role=\"textbox\" [placeholder]=\"(data.length == 0) ? placeholder : ''\">\n                </li>\n                <li class=\"select2-selection__arrow\" role=\"presentation\"><b role=\"presentation\"></b></li>\n            </ul>\n        </span>\n        </span>\n        <span class=\"dropdown-wrapper\" aria-hidden=\"true\"></span>\n    </span>\n\n        <!--quando clicar campo-->\n        <div [hidden]=\"!aberto\">\n        <span class=\"select2-container select2-container--bootstrap select2-container--open\">\n            <span class=\"select2-dropdown select2-dropdown--below\" style=\"z-index: 999999\" dir=\"ltr\" >\n                <span class=\"select2-results\">\n                    <ul class=\"select2-results__options\" role=\"tree\"  aria-expanded=\"true\" aria-hidden=\"false\">\n                        <span [style.display]=\"(exibirMensagemCaracteresMinimo) ? 'none': ''\">\n                            <span [hidden]=\"valoresExibir.length == 0\" >\n                                <li *ngFor=\"let item of valoresExibir\" (click)=\"selecionar(item)\" class=\"select2-results__option\" highlight=\"select2-results__option--highlighted\" role=\"treeitem\" [attr.aria-selected]=\"((_value) && (item == _value)) ? true : false\">\n                                    <span  [inner-template]=\"templateResultado || templateResultadoInterno\" [item]=\"item\"></span>\n                                </li>\n                            </span>\n                            <li [style.display]=\"(valoresExibir.length > 0) ? 'none' : ''\"  class=\"select2-results__option select2-results__message\" aria-live=\"assertive\">\n                                <span  [inner-template]=\"templateSemResultado || templateSemResultadoInterno\" [item]=\"{pesquisa:valorPesquisado}\"></span>\n                            </li>\n                        </span>\n                        <li [style.display]=\"(exibirMensagemCaracteresMinimo == false) ? 'none': ''\" class=\"select2-results__option select2-results__message\">\n                            Digite {{minimoCaracteres}} ou mais caracteres para realizar a busca\n                        </li>\n                    </ul>\n                </span>\n            </span>\n        </span>\n        </div>\n\n\n\n        <ng-template #templateSemResultadoInterno>\n            Nenhum resultado encontrado\n        </ng-template>\n        <ng-template #templateResultadoInterno let-valor>\n            {{valor}}\n        </ng-template>\n        <ng-template #templateSelecionadoInterno let-valor>\n        <span *ngIf=\"valor\">\n            <li *ngFor=\"let item of valor.data\" class=\"select2-selection__choice\">\n                <span class=\"select2-selection__choice__remove\" role=\"presentation\" (click)=\"valor.remove(item, $event)\">\u00D7</span>\n                {{item}}\n            </li>\n        </span>\n        </ng-template>\n    ",
                providers: [
                    {
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: forwardRef(function () { return TagComponent; }),
                        multi: true
                    }
                ],
                host: {
                    '(document:click)': 'clickForaComponent($event)',
                    '(focus)': 'setFocus(true)',
                    '(blur)': 'setFocus(false)',
                },
            },] },
];
/** @nocollapse */
TagComponent.ctorParameters = function () { return [
    { type: ElementRef, },
    { type: NgZone, },
]; };
TagComponent.propDecorators = {
    "name": [{ type: Input },],
    "classe": [{ type: Input },],
    "placeholder": [{ type: Input },],
    "templateResultado": [{ type: Input },],
    "templateSelecionado": [{ type: Input },],
    "templateSemResultado": [{ type: Input },],
    "disabled": [{ type: Input },],
    "valores": [{ type: Input },],
    "change": [{ type: Output },],
    "onSelecionarItem": [{ type: Output },],
    "onBuscar": [{ type: Output },],
    "onApagar": [{ type: Output },],
    "onRemoverItem": [{ type: Output },],
    "onAbrir": [{ type: Output },],
    "onFechar": [{ type: Output },],
    "onLimpar": [{ type: Output },],
    "campoBusca": [{ type: ViewChild, args: ['campoBusca',] },],
    "value": [{ type: Input },],
};
function TagComponent_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    TagComponent.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    TagComponent.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    TagComponent.propDecorators;
    /** @type {?} */
    TagComponent.prototype.data;
    /** @type {?} */
    TagComponent.prototype._valores;
    /** @type {?} */
    TagComponent.prototype.name;
    /** @type {?} */
    TagComponent.prototype.classe;
    /** @type {?} */
    TagComponent.prototype.placeholder;
    /** @type {?} */
    TagComponent.prototype.templateResultado;
    /** @type {?} */
    TagComponent.prototype.templateSelecionado;
    /** @type {?} */
    TagComponent.prototype.templateSemResultado;
    /** @type {?} */
    TagComponent.prototype.disabled;
    /** @type {?} */
    TagComponent.prototype.change;
    /** @type {?} */
    TagComponent.prototype.onSelecionarItem;
    /** @type {?} */
    TagComponent.prototype.onBuscar;
    /** @type {?} */
    TagComponent.prototype.onApagar;
    /** @type {?} */
    TagComponent.prototype.onRemoverItem;
    /** @type {?} */
    TagComponent.prototype.onAbrir;
    /** @type {?} */
    TagComponent.prototype.onFechar;
    /** @type {?} */
    TagComponent.prototype.onLimpar;
    /** @type {?} */
    TagComponent.prototype.campoBusca;
    /** @type {?} */
    TagComponent.prototype.elementRef;
    /** @type {?} */
    TagComponent.prototype.zone;
}
//# sourceMappingURL=tag.component.js.map
